Loading...
Searching...
No Matches
OVALDEF
OVAL
Collaboration diagram for OVALDEF:

## Files

file | oval_definitions.h

## Data Structures

struct | oval_filter
| OVAL filter. More...
struct | oval_definition_model
| Oval definition model. More...
struct | oval_definition
| Oval definition specification. More...
struct | oval_definition_iterator
struct | oval_test
| An Oval_test specifies a technical control by identifying an oval_object that is evaluated on an instrumented host platform and, optionally, an Oval_state instance that matches the object query. More...
struct | oval_test_iterator
struct | oval_object
| An Oval_object instance describes a set of items to look for on an instrumented host platform. More...
struct | oval_object_iterator
struct | oval_state
| An Oval_state instance is a collection of one or more characteristics pertaining to a specific object type. More...
struct | oval_state_iterator
struct | oval_variable
| An oval variable resolves an oval_value stream which specifies constraints for oval_object s and oval_state s. More...
struct | oval_variable_possible_value
struct | oval_variable_possible_restriction
struct | oval_variable_restriction
struct | oval_variable_iterator
struct | oval_affected
| Each OVAL Definition specifies certain type of affected system(s). More...
struct | oval_affected_iterator
struct | oval_reference
| An Oval_reference links an Oval_definition to a definitive external reference. More...
struct | oval_reference_iterator
struct | oval_criteria_node
| Specify oval_definition dependencies. More...
struct | oval_criteria_node_iterator
struct | oval_object_content
| An Oval_object_content instance specifies an oval_object field. More...
struct | oval_object_content_iterator
struct | oval_behavior
| OVAL behavior. More...
struct | oval_behavior_iterator
struct | oval_state_content
| An Oval_state_content instance specifies an oval_state field. More...
struct | oval_state_content_iterator
struct | oval_value
| OVAL object or item entity value. More...
struct | oval_value_iterator
struct | oval_entity
| OVAL entity. More...
struct | oval_entity_iterator
struct | oval_record_field
struct | oval_record_field_iterator
struct | oval_setobject
| OVAL set object. More...
struct | oval_setobject_iteraor
struct | oval_filter_iterator
struct | oval_component
| OVAL variable component Oval_component instances specify evaluation constraints on local variables (see oval_variable_get_type). More...
struct | oval_component_iterator
struct | oval_generator

## Macros

#define | OVAL_FUNCTION 4

## Enumerations

enum | oval_affected_family_t { OVAL_AFCFML_UNKNOWN = 0 , OVAL_AFCFML_CATOS = 1 , OVAL_AFCFML_IOS = 2 , OVAL_AFCFML_MACOS = 3 , OVAL_AFCFML_PIXOS = 4 , OVAL_AFCFML_UNDEFINED = 5 , OVAL_AFCFML_UNIX = 6 , OVAL_AFCFML_WINDOWS = 7 }
| Affected family enumeration. More...
enum | oval_criteria_node_type_t { OVAL_NODETYPE_UNKNOWN = 0 , OVAL_NODETYPE_CRITERIA = 1 , OVAL_NODETYPE_CRITERION = 2 , OVAL_NODETYPE_EXTENDDEF = 3 }
| Criteria node type.
enum | oval_operator_t { OVAL_OPERATOR_UNKNOWN = 0 , OVAL_OPERATOR_AND = 1 , OVAL_OPERATOR_ONE = 2 , OVAL_OPERATOR_OR = 3 , OVAL_OPERATOR_XOR = 4 }
| Boolean operators.

enum

oval_operation_t {
OVAL_OPERATION_UNKNOWN = 0 , OVAL_OPERATION_BITWISE_AND , OVAL_OPERATION_BITWISE_OR , OVAL_OPERATION_CASE_INSENSITIVE_EQUALS ,
OVAL_OPERATION_CASE_INSENSITIVE_NOT_EQUAL , OVAL_OPERATION_EQUALS , OVAL_OPERATION_GREATER_THAN , OVAL_OPERATION_GREATER_THAN_OR_EQUAL ,
OVAL_OPERATION_LESS_THAN , OVAL_OPERATION_LESS_THAN_OR_EQUAL , OVAL_OPERATION_NOT_EQUAL , OVAL_OPERATION_PATTERN_MATCH ,
OVAL_OPERATION_SUBSET_OF , OVAL_OPERATION_SUPERSET_OF
}

| Operations.
enum | oval_existence_t { OVAL_EXISTENCE_UNKNOWN = 0 , OVAL_ALL_EXIST = 1 , OVAL_ANY_EXIST = 2 , OVAL_AT_LEAST_ONE_EXISTS = 3 , OVAL_ONLY_ONE_EXISTS = 4 , OVAL_NONE_EXIST = 5 }
| Existence check enumeration.
enum | oval_check_t { OVAL_CHECK_UNKNOWN = 0 , OVAL_CHECK_ALL = 1 , OVAL_CHECK_AT_LEAST_ONE = 2 , OVAL_CHECK_NONE_EXIST = 3 , OVAL_CHECK_NONE_SATISFY = 4 , OVAL_CHECK_ONLY_ONE = 5 }
| Check enumeration.
enum | oval_object_content_type_t { OVAL_OBJECTCONTENT_UNKNOWN = 0 , OVAL_OBJECTCONTENT_ENTITY = 1 , OVAL_OBJECTCONTENT_SET = 2 , OVAL_OBJECTCONTENT_FILTER = 3 }
| Type of object content.
enum | oval_entity_type_t { OVAL_ENTITY_TYPE_UNKNOWN , OVAL_ENTITY_TYPE_ANY , OVAL_ENTITY_TYPE_BINARY , OVAL_ENTITY_TYPE_BOOLEAN , OVAL_ENTITY_TYPE_FLOAT , OVAL_ENTITY_TYPE_INTEGER , OVAL_ENTITY_TYPE_STRING }
| Type of OVAL entity.
enum | oval_filter_action_t { OVAL_FILTER_ACTION_UNKNOWN = 0 , OVAL_FILTER_ACTION_EXCLUDE , OVAL_FILTER_ACTION_INCLUDE }
| Type of filter action.

enum

oval_datatype_t {
OVAL_DATATYPE_UNKNOWN = 0 , OVAL_DATATYPE_BINARY , OVAL_DATATYPE_BOOLEAN , OVAL_DATATYPE_EVR_STRING ,
OVAL_DATATYPE_FILESET_REVISION , OVAL_DATATYPE_FLOAT , OVAL_DATATYPE_INTEGER , OVAL_DATATYPE_IOS_VERSION ,
OVAL_DATATYPE_IPV4ADDR , OVAL_DATATYPE_IPV6ADDR , OVAL_DATATYPE_RECORD , OVAL_DATATYPE_SEXP ,
OVAL_DATATYPE_STRING , OVAL_DATATYPE_STRING_M , OVAL_DATATYPE_VERSION , OVAL_DATATYPE_DEBIAN_EVR_STRING
}

| Datatypes.
enum | oval_entity_varref_type_t { OVAL_ENTITY_VARREF_UNKNOWN , OVAL_ENTITY_VARREF_NONE , OVAL_ENTITY_VARREF_ATTRIBUTE , OVAL_ENTITY_VARREF_ELEMENT }
| Varref types.
enum | oval_setobject_type_t { OVAL_SET_UNKNOWN , OVAL_SET_AGGREGATE , OVAL_SET_COLLECTIVE }
| OVAL set object types.
enum | oval_setobject_operation_t { OVAL_SET_OPERATION_UNKNOWN , OVAL_SET_OPERATION_COMPLEMENT = 1 , OVAL_SET_OPERATION_INTERSECTION = 2 , OVAL_SET_OPERATION_UNION = 3 }
| Set operations.
enum | oval_variable_type_t { OVAL_VARIABLE_UNKNOWN , OVAL_VARIABLE_EXTERNAL , OVAL_VARIABLE_CONSTANT , OVAL_VARIABLE_LOCAL }
| OVAL variable types.

enum

oval_component_type_t {
OVAL_COMPONENT_UNKNOWN = 0 , OVAL_COMPONENT_LITERAL = 1 , OVAL_COMPONENT_OBJECTREF = 2 , OVAL_COMPONENT_VARREF = 3 ,
OVAL_COMPONENT_FUNCTION = 4 , OVAL_FUNCTION_BEGIN = OVAL_FUNCTION + 1 , OVAL_FUNCTION_CONCAT = OVAL_FUNCTION + 2 , OVAL_FUNCTION_END = OVAL_FUNCTION + 3 ,
OVAL_FUNCTION_SPLIT = OVAL_FUNCTION + 4 , OVAL_FUNCTION_SUBSTRING = OVAL_FUNCTION + 5 , OVAL_FUNCTION_TIMEDIF = OVAL_FUNCTION + 6 , OVAL_FUNCTION_ESCAPE_REGEX = OVAL_FUNCTION + 7 ,
OVAL_FUNCTION_REGEX_CAPTURE = OVAL_FUNCTION + 8 , OVAL_FUNCTION_ARITHMETIC = OVAL_FUNCTION + 9 , OVAL_FUNCTION_COUNT = OVAL_FUNCTION + 10 , OVAL_FUNCTION_UNIQUE = OVAL_FUNCTION + 11 ,
OVAL_FUNCTION_GLOB_TO_REGEX = OVAL_FUNCTION + 12 , OVAL_FUNCTION_LAST = OVAL_FUNCTION + 13
}

| Component types.
enum | oval_arithmetic_operation_t { OVAL_ARITHMETIC_UNKNOWN = 0 , OVAL_ARITHMETIC_ADD = 1 , OVAL_ARITHMETIC_MULTIPLY = 2 , OVAL_ARITHMETIC_SUBTRACT = 3 , OVAL_ARITHMETIC_DIVIDE = 4 }
| Arithmetic format enumeration.
enum | oval_datetime_format_t { OVAL_DATETIME_UNKNOWN = 0 , OVAL_DATETIME_YEAR_MONTH_DAY = 1 , OVAL_DATETIME_MONTH_DAY_YEAR = 2 , OVAL_DATETIME_DAY_MONTH_YEAR = 3 , OVAL_DATETIME_WIN_FILETIME = 4 , OVAL_DATETIME_SECONDS_SINCE_EPOCH = 5 , OVAL_DATETIME_CIM_DATETIME = 6 }
| Datetime format enumeration.
enum | oval_record_field_type_t { OVAL_RECORD_FIELD_UNKNOWN = 0 , OVAL_RECORD_FIELD_STATE = 1 , OVAL_RECORD_FIELD_ITEM = 2 }

## Functions

struct oval_filter * | oval_filter_new (struct oval_definition_model *model)
void | oval_filter_free (struct oval_filter *filter)
struct oval_filter * | oval_filter_clone (struct oval_definition_model *new_model, struct oval_filter *old_filter)
bool | oval_filter_iterator_has_more (struct oval_filter_iterator *oc_filter)
struct oval_filter * | oval_filter_iterator_next (struct oval_filter_iterator *oc_filter)
void | oval_filter_iterator_free (struct oval_filter_iterator *oc_filter)
struct oval_state * | oval_filter_get_state (struct oval_filter *filter)
oval_filter_action_t | oval_filter_get_filter_action (struct oval_filter *filter)
void | oval_filter_set_state (struct oval_filter *filter, struct oval_state *state)
void | oval_filter_set_filter_action (struct oval_filter *filter, oval_filter_action_t action)
int | oval_filter_parse_tag (xmlTextReaderPtr reader, struct oval_parser_context *context, oval_filter_consumer consumer, void *user)
xmlNode * | oval_filter_to_dom (struct oval_filter *filter, xmlDoc *doc, xmlNode *parent)
OSCAP_API oval_family_t | oval_subtype_get_family (oval_subtype_t)
| Get the family associated with a given subtype.
OSCAP_API const char * | oval_operator_get_text (oval_operator_t)
OSCAP_API const char * | oval_subtype_get_text (oval_subtype_t)
OSCAP_API const char * | oval_subtype_to_str (oval_subtype_t)
OSCAP_API oval_subtype_t | oval_subtype_from_str (const char *family_str, const char *subtype_str)
OSCAP_API const char * | oval_family_get_text (oval_family_t)
OSCAP_API const char * | oval_check_get_text (oval_check_t)
OSCAP_API const char * | oval_existence_get_text (oval_existence_t)
OSCAP_API const char * | oval_affected_family_get_text (oval_affected_family_t)
OSCAP_API const char * | oval_datatype_get_text (oval_datatype_t)
OSCAP_API oval_datatype_t | oval_datatype_from_text (const char *)
OSCAP_API const char * | oval_operation_get_text (oval_operation_t)
OSCAP_API oval_operation_t | oval_operation_from_text (const char *)
OSCAP_API const char * | oval_set_operation_get_text (oval_setobject_operation_t)
OSCAP_API const char * | oval_datetime_format_get_text (oval_datetime_format_t)
OSCAP_API const char * | oval_arithmetic_operation_get_text (oval_arithmetic_operation_t)
OSCAP_API const char * | oval_filter_action_get_text (oval_filter_action_t)
OSCAP_API struct oval_generator * | oval_generator_new (void)
OSCAP_API void | oval_generator_free (struct oval_generator *generator)
OSCAP_API struct oval_generator * | oval_generator_clone (struct oval_generator *old_generator)
OSCAP_API char * | oval_generator_get_product_name (struct oval_generator *generator)
OSCAP_API char * | oval_generator_get_product_version (struct oval_generator *generator)
OSCAP_API const char * | oval_generator_get_core_schema_version (struct oval_generator *generator)
OSCAP_API char * | oval_generator_get_timestamp (struct oval_generator *generator)
OSCAP_API const char * | oval_generator_get_platform_schema_version (struct oval_generator *generator, const char *platform)
OSCAP_API void | oval_generator_set_product_name (struct oval_generator *generator, const char *product_name)
OSCAP_API void | oval_generator_set_product_version (struct oval_generator *generator, const char *product_version)
OSCAP_API void | oval_generator_set_core_schema_version (struct oval_generator *generator, const char *schema_version)
OSCAP_API void | oval_generator_add_platform_schema_version (struct oval_generator *generator, const char *platform, const char *schema_version)
OSCAP_API void | oval_generator_set_timestamp (struct oval_generator *generator, const char *timestamp)
OSCAP_API void | oval_generator_update_timestamp (struct oval_generator *generator)
OSCAP_API struct oval_definition_model * | oval_definition_model::oval_definition_model_new (void)
| Create an empty oval_definition_model.
OSCAP_API struct oval_definition_model * | oval_definition_model::oval_definition_model_import_source (struct oscap_source *source)
| Import the content of the oscap_source into the oval_definition_model.
OSCAP_API struct oval_definition_model * | oval_definition_model::oval_definition_model_clone (struct oval_definition_model *)
| Copy an oval_definition_model.
OSCAP_API int | oval_definition_model::oval_definition_model_export (struct oval_definition_model *, const char *file)
| Export an oval_definition_model into file.
OSCAP_API void | oval_definition_model::oval_definition_model_free (struct oval_definition_model *model)
| Free OVAL object model and all binded variable models.
OSCAP_API struct oval_definition * | oval_definition::oval_definition_new (struct oval_definition_model *, const char *id)
| Construct an instance of oval_definition.
OSCAP_API struct oval_definition * | oval_definition::oval_definition_clone (struct oval_definition_model *new_model, struct oval_definition *old_definition)
| Clone instance of oval_definition and add it to the specified oval_definition_model.
OSCAP_API void | oval_definition::oval_definition_free (struct oval_definition *)
| Release an instance of oval_definition.
OSCAP_API struct oval_test * | oval_test::oval_test_new (struct oval_definition_model *, const char *id)
| Construct new instance of oval_test.
OSCAP_API struct oval_test * | oval_test::oval_test_clone (struct oval_definition_model *new_model, struct oval_test *old_test)
| Clone instance of oval_test and add it to the specified oval_definition_model.
OSCAP_API void | oval_test::oval_test_free (struct oval_test *)
| Destruct instance of oval_test.
OSCAP_API struct oval_object * | oval_object::oval_object_new (struct oval_definition_model *, const char *id)
| Construct new intance of oval_object.
OSCAP_API struct oval_object * | oval_object::oval_object_clone (struct oval_definition_model *new_model, struct oval_object *old_object)
| Clone instance of oval_object and add it to the specified oval_definition_model.
OSCAP_API void | oval_object::oval_object_free (struct oval_object *)
| Free instance of oval_object.
OSCAP_API struct oval_state * | oval_state::oval_state_new (struct oval_definition_model *, const char *id)
| Construct new intance of oval_state.
OSCAP_API struct oval_state * | oval_state::oval_state_clone (struct oval_definition_model *new_model, struct oval_state *old_state)
| Clone instance of oval_state and add it to the specified oval_definition_model.
OSCAP_API void | oval_state::oval_state_free (struct oval_state *)
| Free instance of oval_state.
OSCAP_API struct oval_variable * | oval_variable::oval_variable_new (struct oval_definition_model *model, const char *id, oval_variable_type_t type)
| Construct new instance of oval_variable.
OSCAP_API struct oval_variable * | oval_variable::oval_variable_clone (struct oval_definition_model *new_model, struct oval_variable *old_variable)
| Clone instance of oval_variable and add it to the specified oval_definition_model.
OSCAP_API void | oval_variable::oval_variable_free (struct oval_variable *)
| Free instance of oval_variable.
OSCAP_API struct oval_variable_possible_value * | oval_variable_possible_value::oval_variable_possible_value_new (const char *hint, const char *value)
| Construct new instance of possible_value element.
OSCAP_API void | oval_variable_possible_value::oval_variable_possible_value_free (struct oval_variable_possible_value *pv)
| Free instance of possible_value.
OSCAP_API char * | oval_variable_possible_value::oval_variable_possible_value_get_hint (struct oval_variable_possible_value *pv)
| Get the hint of the possible_value.
OSCAP_API char * | oval_variable_possible_value::oval_variable_possible_value_get_value (struct oval_variable_possible_value *pv)
| Get the value of the possible value.
OSCAP_API struct oval_variable_possible_restriction * | oval_variable_possible_restriction::oval_variable_possible_restriction_new (oval_operator_t, const char *)
| Construct new instance of possible_restriction element.
OSCAP_API void | oval_variable_possible_restriction::oval_variable_possible_restriction_free (struct oval_variable_possible_restriction *pr)
| Free instance of possible_restriction.
OSCAP_API struct oval_variable_restriction * | oval_variable_restriction::oval_variable_restriction_new (oval_operation_t operation, const char *value)
| Construct new instance of restriction element.
OSCAP_API void | oval_variable_restriction::oval_variable_restriction_free (struct oval_variable_restriction *r)
| Free instance of restriction element.
OSCAP_API oval_operation_t | oval_variable_restriction::oval_variable_restriction_get_operation (struct oval_variable_restriction *restriction)
| Get the operation of a restriction element.
OSCAP_API char * | oval_variable_restriction::oval_variable_restriction_get_value (struct oval_variable_restriction *restriction)
| Get the value of a restriction element.
OSCAP_API struct oval_affected * | oval_affected::oval_affected_new (struct oval_definition_model *)
| Construct instance of oval_affected.
OSCAP_API struct oval_affected * | oval_affected::oval_affected_clone (struct oval_definition_model *new_model, struct oval_affected *old_affected)
| Clone instance of oval_affected.
OSCAP_API void | oval_affected::oval_affected_free (struct oval_affected *)
| Release instance of oval_affected.
OSCAP_API struct oval_reference * | oval_reference::oval_reference_new (struct oval_definition_model *)
OSCAP_API struct oval_reference * | oval_reference::oval_reference_clone (struct oval_definition_model *new_model, struct oval_reference *old_reference)
OSCAP_API void | oval_reference::oval_reference_free (struct oval_reference *)
OSCAP_API struct oval_criteria_node * | oval_criteria_node::oval_criteria_node_new (struct oval_definition_model *, oval_criteria_node_type_t type)
| Construct an instance of oval_criteria_node.
OSCAP_API struct oval_criteria_node * | oval_criteria_node::oval_criteria_node_clone (struct oval_definition_model *new_model, struct oval_criteria_node *old_node)
| Clone an instance of oval_criteria_node.
OSCAP_API void | oval_criteria_node::oval_criteria_node_free (struct oval_criteria_node *)
| Free an instance of oval_criteria_node.
OSCAP_API struct oval_object_content * | oval_object_content::oval_object_content_new (struct oval_definition_model *model, oval_object_content_type_t type)
OSCAP_API struct oval_object_content * | oval_object_content::oval_object_content_clone (struct oval_definition_model *new_model, struct oval_object_content *old_content)
OSCAP_API void | oval_object_content::oval_object_content_free (struct oval_object_content *)
OSCAP_API struct oval_behavior * | oval_behavior::oval_behavior_new (struct oval_definition_model *)
OSCAP_API struct oval_behavior * | oval_behavior::oval_behavior_clone (struct oval_definition_model *new_model, struct oval_behavior *old_behavior)
OSCAP_API void | oval_behavior::oval_behavior_free (struct oval_behavior *)
OSCAP_API struct oval_state_content * | oval_state_content::oval_state_content_new (struct oval_definition_model *)
OSCAP_API struct oval_state_content * | oval_state_content::oval_state_content_clone (struct oval_definition_model *new_model, struct oval_state_content *old_content)
OSCAP_API void | oval_state_content::oval_state_content_free (struct oval_state_content *)
OSCAP_API struct oval_value * | oval_value::oval_value_new (oval_datatype_t datatype, char *text_value)
OSCAP_API struct oval_value * | oval_value::oval_value_clone (struct oval_value *old_value)
OSCAP_API void | oval_value::oval_value_free (struct oval_value *)
OSCAP_API struct oval_entity * | oval_entity::oval_entity_new (struct oval_definition_model *)
OSCAP_API struct oval_entity * | oval_entity::oval_entity_clone (struct oval_definition_model *model, struct oval_entity *old_entity)
OSCAP_API void | oval_entity::oval_entity_free (struct oval_entity *)
OSCAP_API struct oval_record_field * | oval_record_field::oval_record_field_new (oval_record_field_type_t)
OSCAP_API struct oval_record_field * | oval_record_field::oval_record_field_clone (struct oval_record_field *)
OSCAP_API void | oval_record_field::oval_record_field_free (struct oval_record_field *)
OSCAP_API struct oval_filter * | oval_filter::oval_filter_new (struct oval_definition_model *)
OSCAP_API void | oval_filter::oval_filter_free (struct oval_filter *)
OSCAP_API struct oval_filter * | oval_filter::oval_filter_clone (struct oval_definition_model *, struct oval_filter *)
OSCAP_API struct oval_setobject * | oval_setobject::oval_setobject_new (struct oval_definition_model *)
OSCAP_API struct oval_setobject * | oval_setobject::oval_setobject_clone (struct oval_definition_model *new_model, struct oval_setobject *old_setobject)
OSCAP_API void | oval_setobject::oval_setobject_free (struct oval_setobject *)
OSCAP_API struct oval_component * | oval_component::oval_component_new (struct oval_definition_model *, oval_component_type_t type)
| Construct new intance of Oval_component.
OSCAP_API struct oval_component * | oval_component::oval_component_clone (struct oval_definition_model *new_model, struct oval_component *old_component)
| Clone instance of Oval_component.
OSCAP_API void | oval_component::oval_component_free (struct oval_component *)
| Free instance of Oval_component.

## Setters

OSCAP_API void | oval_definition_model_set_generator (struct oval_definition_model *model, struct oval_generator *generator)
OSCAP_API void | oval_definition_model_clear_external_variables (struct oval_definition_model *)
OSCAP_API void | oval_variable_clear_values (struct oval_variable *)
OSCAP_API void | oval_setobject_set_type (struct oval_setobject *, oval_setobject_type_t)
OSCAP_API int | oval_definition_model::oval_definition_model_bind_variable_model (struct oval_definition_model *, struct oval_variable_model *)
| Bind an oval_variable_model to the specified oval_definition_model.
OSCAP_API void | oval_definition::oval_definition_set_version (struct oval_definition *, int version)
| Set attribute oval_definition->version.
OSCAP_API void | oval_definition::oval_definition_set_class (struct oval_definition *, oval_definition_class_t)
| Set attribute oval_definition->class.
OSCAP_API void | oval_definition::oval_definition_set_deprecated (struct oval_definition *, bool deprecated)
| Set attribute oval_definition->deprecated.
OSCAP_API void | oval_definition::oval_definition_set_title (struct oval_definition *, char *title)
| Set attribute oval_definition->title.
OSCAP_API void | oval_definition::oval_definition_set_description (struct oval_definition *, char *description)
| Set attribute oval_definition->description.
OSCAP_API void | oval_definition::oval_definition_add_affected (struct oval_definition *, struct oval_affected *affected)
| Append instance of oval_affected to attribute oval_definition->affected.
OSCAP_API void | oval_definition::oval_definition_add_reference (struct oval_definition *, struct oval_reference *reference)
| Append instance of oval_reference to attribute oval_definition->references.
OSCAP_API void | oval_definition::oval_definition_add_note (struct oval_definition *, char *note)
| Append a copy of the note parameter to attribute Oval_definition->notes.
OSCAP_API void | oval_definition::oval_definition_set_criteria (struct oval_definition *, struct oval_criteria_node *criteria)
| Set attribute oval_definition->criteria.
OSCAP_API void | oval_test::oval_test_set_subtype (struct oval_test *, oval_subtype_t subtype)
| Sets attributes oval_test->subtype and Oval_test->family.
OSCAP_API void | oval_test::oval_test_add_note (struct oval_test *, char *note)
| Appends a copy of the note parameter to attribute oval_test->notes.
OSCAP_API void | oval_test::oval_test_set_comment (struct oval_test *, char *comment)
| Sets a copy of the comment parameter to attribute oval_test->comment.
OSCAP_API void | oval_test::oval_test_set_deprecated (struct oval_test *, bool deprecated)
| Sets attribute oval_test->deprecated.
OSCAP_API void | oval_test::oval_test_set_version (struct oval_test *, int version)
| Sets attribute oval_test->version.
OSCAP_API void | oval_test::oval_test_set_state_operator (struct oval_test *, oval_operator_t)
| Sets attribute oval_test->state_operator.
OSCAP_API void | oval_test::oval_test_set_existence (struct oval_test *, oval_existence_t)
| Sets attribute oval_test->existence.
OSCAP_API void | oval_test::oval_test_set_check (struct oval_test *, oval_check_t)
| Sets attribute oval_test->check.
OSCAP_API void | oval_test::oval_test_set_object (struct oval_test *, struct oval_object *)
| Sets attribute oval_test->object.
OSCAP_API void | oval_test::oval_test_add_state (struct oval_test *, struct oval_state *)
| Add the specified state to the state list of the specified test.
OSCAP_API void | oval_object::oval_object_set_subtype (struct oval_object *, oval_subtype_t subtype)
| Sets attributes oval_object->subtype and oval_object->family.
OSCAP_API void | oval_object::oval_object_add_note (struct oval_object *, char *note)
| Appends a copy of the note parameter to attribute oval_object->notes.
OSCAP_API void | oval_object::oval_object_set_comment (struct oval_object *, char *comment)
| Sets a copy of the comment parameter to attribute oval_object->comment.
OSCAP_API void | oval_object::oval_object_set_deprecated (struct oval_object *, bool deprecated)
| Sets attribute oval_object->deprecated.
OSCAP_API void | oval_object::oval_object_set_version (struct oval_object *, int version)
| Sets attribute oval_object->version.
OSCAP_API void | oval_object::oval_object_add_object_content (struct oval_object *, struct oval_object_content *content)
| Append instance of oval_object_content to attribute oval_object->object_contents.
OSCAP_API void | oval_object::oval_object_add_behavior (struct oval_object *, struct oval_behavior *behavior)
| Append instance of oval_behavior to attribute oval_object->behaviors.
OSCAP_API void | oval_state::oval_state_set_subtype (struct oval_state *, oval_subtype_t subtype)
| Sets attributes oval_state->subtype and oval_state->family.
OSCAP_API void | oval_state::oval_state_add_note (struct oval_state *, char *note)
| Appends a copy of the note parameter to attribute oval_state->notes.
OSCAP_API void | oval_state::oval_state_set_comment (struct oval_state *, char *comment)
| Sets a copy of the comment parameter to attribute oval_state->comment.
OSCAP_API void | oval_state::oval_state_set_deprecated (struct oval_state *, bool deprecated)
| Sets attribute oval_state->deprecated.
OSCAP_API void | oval_state::oval_state_set_version (struct oval_state *, int version)
| Sets attribute oval_state->version.
OSCAP_API void | oval_state::oval_state_set_operator (struct oval_state *, oval_operator_t)
| Sets attribute oval_state->operator.
OSCAP_API void | oval_state::oval_state_add_content (struct oval_state *, struct oval_state_content *content)
| Append instance of oval_state_content to attribute oval_state->state_contents.
OSCAP_API void | oval_variable::oval_variable_set_comment (struct oval_variable *, char *comment)
| set attribute oval_variable->comment.
OSCAP_API void | oval_variable::oval_variable_set_version (struct oval_variable *, int version)
| set attribute oval_variable->version.
OSCAP_API void | oval_variable::oval_variable_set_deprecated (struct oval_variable *, bool deprecated)
| set attribute oval_variable->deprecated.
OSCAP_API void | oval_variable::oval_variable_set_datatype (struct oval_variable *, oval_datatype_t)
| set attribute oval_variable->datatype.
OSCAP_API void | oval_variable::oval_variable_add_value (struct oval_variable *, struct oval_value *)
| Append an instance of Oval_value to the attribute Oval_constant->values.
OSCAP_API void | oval_variable::oval_variable_add_possible_value (struct oval_variable *variable, struct oval_variable_possible_value *pv)
| Add a new possible value to an external variable.
OSCAP_API void | oval_variable::oval_variable_add_possible_restriction (struct oval_variable *variable, struct oval_variable_possible_restriction *pr)
| Add a new possible restriction to an external variable.
OSCAP_API void | oval_variable_possible_restriction::oval_variable_possible_restriction_add_restriction (struct oval_variable_possible_restriction *pr, struct oval_variable_restriction *r)
| Add a restriction to the list of possible restrictions.
OSCAP_API void | oval_variable::oval_variable_set_component (struct oval_variable *, struct oval_component *component)
| Bind an instance of Oval_component to the attribute Oval_local->component.
OSCAP_API void | oval_affected::oval_affected_set_family (struct oval_affected *, oval_affected_family_t family)
| Set oval_affected family.
OSCAP_API void | oval_affected::oval_affected_add_platform (struct oval_affected *, char *platform_name)
| Append name to oval_affected platform names.
OSCAP_API void | oval_affected::oval_affected_add_product (struct oval_affected *, char *product_name)
| Append name to oval_affected product names.
OSCAP_API void | oval_reference::oval_reference_set_source (struct oval_reference *, char *)
| Set OVAL reference source.
OSCAP_API void | oval_reference::oval_reference_set_id (struct oval_reference *, char *)
OSCAP_API void | oval_reference::oval_reference_set_url (struct oval_reference *, char *)
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_negate (struct oval_criteria_node *, bool negate)
| Set attribute Oval_criteria_node->negate.
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_applicability_check (struct oval_criteria_node *, bool applicability_check)
| Set attribute Oval_criteria_node->applicability_check.
OSCAP_API void | oval_criteria_node::oval_criteria_set_node_type (struct oval_criteria_node *node, oval_criteria_node_type_t type)
| Set attribute Oval_criteria_node->type.
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_comment (struct oval_criteria_node *, char *comment)
| set attribute Oval_criteria_node->comment.
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_operator (struct oval_criteria_node *, oval_operator_t op)
| Set attribute Oval_criteria->operator.
OSCAP_API void | oval_criteria_node::oval_criteria_node_add_subnode (struct oval_criteria_node *, struct oval_criteria_node *node)
| Append instance of Oval_criteria_node to attribute Oval_criteria->subnodes.
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_test (struct oval_criteria_node *, struct oval_test *)
| Sets attribute Oval_criterion->test.
OSCAP_API void | oval_criteria_node::oval_criteria_node_set_definition (struct oval_criteria_node *, struct oval_definition *)
| Sets attribute Oval_extends->definition.
OSCAP_API void | oval_object_content::oval_object_content_set_type (struct oval_object_content *, oval_object_content_type_t)
OSCAP_API void | oval_object_content::oval_object_content_set_field_name (struct oval_object_content *, char *)
OSCAP_API void | oval_object_content::oval_object_content_set_entity (struct oval_object_content *, struct oval_entity *)
OSCAP_API void | oval_object_content::oval_object_content_set_varCheck (struct oval_object_content *, oval_check_t)
OSCAP_API void | oval_object_content::oval_object_content_set_setobject (struct oval_object_content *, struct oval_setobject *)
OSCAP_API void | oval_object_content::oval_object_content_set_filter (struct oval_object_content *, struct oval_filter *)
OSCAP_API void | oval_behavior::oval_behavior_set_keyval (struct oval_behavior *behavior, const char *key, const char *value)
OSCAP_API void | oval_state_content::oval_state_content_set_entity (struct oval_state_content *, struct oval_entity *)
OSCAP_API void | oval_state_content::oval_state_content_add_record_field (struct oval_state_content *, struct oval_record_field *)
OSCAP_API void | oval_state_content::oval_state_content_set_varcheck (struct oval_state_content *, oval_check_t)
OSCAP_API void | oval_state_content::oval_state_content_set_entcheck (struct oval_state_content *, oval_check_t)
OSCAP_API void | oval_state_content::oval_state_content_set_check_existence (struct oval_state_content *content, oval_existence_t existence)
| Sets the "check_existence" attribute of an OVAL state entity.
OSCAP_API void | oval_value::oval_value_set_datatype (struct oval_value *, oval_datatype_t)
OSCAP_API void | oval_entity::oval_entity_set_type (struct oval_entity *, oval_entity_type_t)
OSCAP_API void | oval_entity::oval_entity_set_datatype (struct oval_entity *, oval_datatype_t)
OSCAP_API void | oval_entity::oval_entity_set_mask (struct oval_entity *, int)
OSCAP_API void | oval_entity::oval_entity_set_varref_type (struct oval_entity *, oval_entity_varref_type_t)
OSCAP_API void | oval_entity::oval_entity_set_variable (struct oval_entity *, struct oval_variable *)
OSCAP_API void | oval_entity::oval_entity_set_value (struct oval_entity *, struct oval_value *)
OSCAP_API void | oval_entity::oval_entity_set_name (struct oval_entity *, char *)
OSCAP_API void | oval_entity::oval_entity_set_operation (struct oval_entity *, oval_operation_t)
OSCAP_API void | oval_record_field::oval_record_field_set_name (struct oval_record_field *, char *)
OSCAP_API void | oval_record_field::oval_record_field_set_value (struct oval_record_field *, char *)
OSCAP_API void | oval_record_field::oval_record_field_set_datatype (struct oval_record_field *, oval_datatype_t)
OSCAP_API void | oval_record_field::oval_record_field_set_mask (struct oval_record_field *, int)
OSCAP_API void | oval_record_field::oval_record_field_set_operation (struct oval_record_field *, oval_operation_t)
OSCAP_API void | oval_record_field::oval_record_field_set_variable (struct oval_record_field *, struct oval_variable *)
OSCAP_API void | oval_record_field::oval_record_field_set_var_check (struct oval_record_field *, oval_check_t)
OSCAP_API void | oval_record_field::oval_record_field_set_ent_check (struct oval_record_field *, oval_check_t)
OSCAP_API void | oval_filter::oval_filter_set_state (struct oval_filter *, struct oval_state *)
OSCAP_API void | oval_filter::oval_filter_set_filter_action (struct oval_filter *, oval_filter_action_t)
OSCAP_API void | oval_setobject::oval_setobject_set_operation (struct oval_setobject *, oval_setobject_operation_t)
OSCAP_API void | oval_setobject::oval_setobject_add_subset (struct oval_setobject *, struct oval_setobject *)
OSCAP_API void | oval_setobject::oval_setobject_add_object (struct oval_setobject *, struct oval_object *)
OSCAP_API void | oval_setobject::oval_setobject_add_filter (struct oval_setobject *, struct oval_filter *)
OSCAP_API void | oval_component::oval_component_set_type (struct oval_component *component, oval_component_type_t type)
| Set type of component Oval_component->type.
OSCAP_API void | oval_component::oval_component_set_object (struct oval_component *, struct oval_object *object)
| set attribute Oval_component_object->object.
OSCAP_API void | oval_component::oval_component_set_item_field (struct oval_component *, char *)
| set attribute Oval_component_object->item_field.
OSCAP_API void | oval_component::oval_component_set_record_field (struct oval_component *, char *)
| set attribute Oval_component_object->record_field.
OSCAP_API void | oval_component::oval_component_set_variable (struct oval_component *, struct oval_variable *variable)
| set attribute Oval_component_object->variable.
OSCAP_API void | oval_component::oval_component_add_function_component (struct oval_component *, struct oval_component *)
OSCAP_API void | oval_component::oval_component_set_arithmetic_operation (struct oval_component *, oval_arithmetic_operation_t)
OSCAP_API void | oval_component::oval_component_set_prefix (struct oval_component *, char *)
OSCAP_API void | oval_component::oval_component_set_suffix (struct oval_component *, char *)
OSCAP_API void | oval_component::oval_component_set_split_delimiter (struct oval_component *, char *)
OSCAP_API void | oval_component::oval_component_set_glob_to_regex_glob_noescape (struct oval_component *, bool)
OSCAP_API void | oval_component::oval_component_set_substring_start (struct oval_component *, int)
OSCAP_API void | oval_component::oval_component_set_substring_length (struct oval_component *, int)
OSCAP_API void | oval_component::oval_component_set_timedif_format_1 (struct oval_component *, oval_datetime_format_t)
OSCAP_API void | oval_component::oval_component_set_timedif_format_2 (struct oval_component *, oval_datetime_format_t)
OSCAP_API void | oval_component::oval_component_set_regex_pattern (struct oval_component *, char *)
OSCAP_API void | oval_component::oval_component_set_literal_value (struct oval_component *, struct oval_value *)

## Getters

OSCAP_API struct oval_generator * | oval_definition_model_get_generator (struct oval_definition_model *model)
OSCAP_API struct oval_definition * | oval_definition_model::oval_definition_model_get_definition (struct oval_definition_model *, const char *id)
| Returns the appended oval_definition having the specified id.
OSCAP_API struct oval_test * | oval_definition_model::oval_definition_model_get_test (struct oval_definition_model *model, const char *id)
| Get oval test by ID.
OSCAP_API struct oval_object * | oval_definition_model::oval_definition_model_get_object (struct oval_definition_model *model, const char *id)
| Get OVAL object by ID.
OSCAP_API struct oval_state * | oval_definition_model::oval_definition_model_get_state (struct oval_definition_model *model, const char *id)
| Get OVAL state by ID.
OSCAP_API struct oval_variable * | oval_definition_model::oval_definition_model_get_variable (struct oval_definition_model *model, const char *id)
| Get OVAL variable by ID.
OSCAP_API struct oval_definition_iterator * | oval_definition_model::oval_definition_model_get_definitions (struct oval_definition_model *model)
| Returns all appended oval_definition instances.
OSCAP_API struct oval_test_iterator * | oval_definition_model::oval_definition_model_get_tests (struct oval_definition_model *model)
| Get OVAL tests.
OSCAP_API struct oval_object_iterator * | oval_definition_model::oval_definition_model_get_objects (struct oval_definition_model *model)
| Get OVAL objects.
OSCAP_API struct oval_state_iterator * | oval_definition_model::oval_definition_model_get_states (struct oval_definition_model *model)
| Get OVAL states.
OSCAP_API struct oval_variable_iterator * | oval_definition_model::oval_definition_model_get_variables (struct oval_definition_model *model)
| Get OVAL variables.
OSCAP_API const char * | oval_definition_model::oval_definition_model_supported (void)
| Get supported version of OVAL XML.
OSCAP_API struct oval_variable_model_iterator * | oval_definition_model::oval_definition_model_get_variable_models (struct oval_definition_model *)
| Return the list of variable models bound to the specified oval_definition_model.
OSCAP_API char * | oval_definition::oval_definition_get_id (struct oval_definition *)
| Returns attribute oval_definition->id (identifier).
OSCAP_API int | oval_definition::oval_definition_get_version (struct oval_definition *)
| Returns attribute oval_definition->version.
OSCAP_API oval_definition_class_t | oval_definition::oval_definition_get_class (struct oval_definition *)
| Returns attribute oval_definition->class.
OSCAP_API bool | oval_definition::oval_definition_get_deprecated (struct oval_definition *)
| Returns attribute oval_definition->deprecated.
OSCAP_API char * | oval_definition::oval_definition_get_title (struct oval_definition *)
| Returns attribute oval_definition->title.
OSCAP_API char * | oval_definition::oval_definition_get_description (struct oval_definition *)
| Returns attribute oval_definition->description.
OSCAP_API struct oval_affected_iterator * | oval_definition::oval_definition_get_affected (struct oval_definition *)
| Returns attribute oval_definition->affected.
OSCAP_API struct oval_reference_iterator * | oval_definition::oval_definition_get_references (struct oval_definition *)
| Returns attribute oval_definition->references.
OSCAP_API struct oval_string_iterator * | oval_definition::oval_definition_get_notes (struct oval_definition *)
| Returns attribute oval_definition->notes.
OSCAP_API struct oval_criteria_node * | oval_definition::oval_definition_get_criteria (struct oval_definition *)
| Returns attribute oval_definition->criteria.
OSCAP_API oval_family_t | oval_test::oval_test_get_family (struct oval_test *)
| Returns attribute Oval_test->family.
OSCAP_API oval_subtype_t | oval_test::oval_test_get_subtype (struct oval_test *)
| Returns attribute Oval_test->subtype.
OSCAP_API struct oval_string_iterator * | oval_test::oval_test_get_notes (struct oval_test *)
| Returns attribute oval_test->notes.
OSCAP_API char * | oval_test::oval_test_get_comment (struct oval_test *)
| Returns attribute Oval_test->comment.
OSCAP_API char * | oval_test::oval_test_get_id (struct oval_test *)
| Returns attribute oval_test->id.
OSCAP_API bool | oval_test::oval_test_get_deprecated (struct oval_test *)
| Returns attribute oval_test->deprecated.
OSCAP_API int | oval_test::oval_test_get_version (struct oval_test *)
| Returns attribute oval_test->version.
OSCAP_API oval_operator_t | oval_test::oval_test_get_state_operator (struct oval_test *)
| Returns attribute oval_test->state_operator.
OSCAP_API oval_existence_t | oval_test::oval_test_get_existence (struct oval_test *)
| Returns attribute oval_test->existence.
OSCAP_API oval_check_t | oval_test::oval_test_get_check (struct oval_test *)
| Returns attribute oval_test->check.
OSCAP_API struct oval_object * | oval_test::oval_test_get_object (struct oval_test *)
| Returns attribute oval_test->object.
OSCAP_API struct oval_state_iterator * | oval_test::oval_test_get_states (struct oval_test *)
| Returns attribute oval_test->states.
OSCAP_API oval_family_t | oval_object::oval_object_get_family (struct oval_object *)
| Returns attribute oval_object->family.
OSCAP_API const char * | oval_object::oval_object_get_name (struct oval_object *)
| Returns the name of an oval_object.
OSCAP_API oval_subtype_t | oval_object::oval_object_get_subtype (struct oval_object *)
| Returns attribute oval_object->subtype.
OSCAP_API struct oval_string_iterator * | oval_object::oval_object_get_notes (struct oval_object *)
| Returns attribute oval_object->notes.
OSCAP_API char * | oval_object::oval_object_get_comment (struct oval_object *)
| Returns attribute oval_object->comment.
OSCAP_API char * | oval_object::oval_object_get_id (struct oval_object *)
| Returns attribute oval_object->id.
OSCAP_API bool | oval_object::oval_object_get_deprecated (struct oval_object *)
| Returns attribute oval_object->deprecated.
OSCAP_API int | oval_object::oval_object_get_version (struct oval_object *)
| Returns attribute oval_object->version.
OSCAP_API oval_schema_version_t | oval_object::oval_object_get_platform_schema_version (struct oval_object *object)
| Returns schema version of the associated platform extension definition model.
OSCAP_API struct oval_object_content_iterator * | oval_object::oval_object_get_object_contents (struct oval_object *)
| Returns attribute oval_object->contents.
OSCAP_API struct oval_behavior_iterator * | oval_object::oval_object_get_behaviors (struct oval_object *)
| Returns attribute oval_object->behaviors.
OSCAP_API oval_family_t | oval_state::oval_state_get_family (struct oval_state *)
| Returns attribute oval_state->family.
OSCAP_API const char * | oval_state::oval_state_get_name (struct oval_state *)
| Returns the name of an oval_state.
OSCAP_API oval_subtype_t | oval_state::oval_state_get_subtype (struct oval_state *)
| Returns attribute oval_state->subtype.
OSCAP_API struct oval_string_iterator * | oval_state::oval_state_get_notes (struct oval_state *)
| Returns attribute oval_state->notes.
OSCAP_API char * | oval_state::oval_state_get_comment (struct oval_state *)
| Returns attribute oval_state->comment.
OSCAP_API char * | oval_state::oval_state_get_id (struct oval_state *)
| Returns attribute oval_state->id.
OSCAP_API bool | oval_state::oval_state_get_deprecated (struct oval_state *)
| Returns attribute oval_state->deprecated.
OSCAP_API int | oval_state::oval_state_get_version (struct oval_state *)
| Returns attribute oval_state->version.
OSCAP_API int | oval_state::oval_state_get_operator (struct oval_state *)
| Returns attribute oval_state->operator.
OSCAP_API struct oval_state_content_iterator * | oval_state::oval_state_get_contents (struct oval_state *)
| Returns attribute oval_state->contents.
OSCAP_API char * | oval_variable::oval_variable_get_id (struct oval_variable *)
| Returns attribute oval_variable->id.
OSCAP_API char * | oval_variable::oval_variable_get_comment (struct oval_variable *)
| Returns attribute oval_variable->comment.
OSCAP_API int | oval_variable::oval_variable_get_version (struct oval_variable *)
| Returns attribute oval_variable->version.
OSCAP_API bool | oval_variable::oval_variable_get_deprecated (struct oval_variable *)
| Returns attribute oval_variable->deprecated.
OSCAP_API oval_variable_type_t | oval_variable::oval_variable_get_type (struct oval_variable *)
| Returns attribute oval_variable->type.
OSCAP_API oval_datatype_t | oval_variable::oval_variable_get_datatype (struct oval_variable *)
| Returns attribute oval_variable->datatype.
OSCAP_API struct oval_value_iterator * | oval_variable::oval_variable_get_values (struct oval_variable *)
| Returns attribute Oval_external/ Oval_constant->values.
OSCAP_API struct oval_component * | oval_variable::oval_variable_get_component (struct oval_variable *)
| Returns attribute Oval_local->component.
OSCAP_API struct oval_variable_possible_value_iterator * | oval_variable::oval_variable_get_possible_values2 (struct oval_variable *variable)
| Get list of allowed values for an external variable.
OSCAP_API struct oval_variable_possible_restriction_iterator * | oval_variable::oval_variable_get_possible_restrictions2 (struct oval_variable *variable)
| Get list of constraints for an external variable.
OSCAP_API struct oval_variable_restriction_iterator * | oval_variable_possible_restriction::oval_variable_possible_restriction_get_restrictions2 (struct oval_variable_possible_restriction *possible_restriction)
| Get restrictions from one possible_restriction element.
OSCAP_API oval_operator_t | oval_variable_possible_restriction::oval_variable_possible_restriction_get_operator (struct oval_variable_possible_restriction *possible_restriction)
| Get operator of possible_restriction element.
OSCAP_API char * | oval_variable_possible_restriction::oval_variable_possible_restriction_get_hint (struct oval_variable_possible_restriction *possible_restriction)
| Get hint of possible_restriction element.
OSCAP_API const char * | oval_variable::oval_component_type_get_text (oval_component_type_t type)
| Returns attribute Oval_component_type->text.
OSCAP_API oval_affected_family_t | oval_affected::oval_affected_get_family (struct oval_affected *)
| Get member value oval_affected family.
OSCAP_API struct oval_string_iterator * | oval_affected::oval_affected_get_platforms (struct oval_affected *)
| Get member values oval_affected platform_names.
OSCAP_API struct oval_string_iterator * | oval_affected::oval_affected_get_products (struct oval_affected *)
| Get member values oval_affected product_names.
OSCAP_API char * | oval_reference::oval_reference_get_source (struct oval_reference *)
| Get OVAL reference source.
OSCAP_API char * | oval_reference::oval_reference_get_id (struct oval_reference *)
| Get OVAL reference ID.
OSCAP_API char * | oval_reference::oval_reference_get_url (struct oval_reference *)
| Get OVAL reference URL.
OSCAP_API oval_criteria_node_type_t | oval_criteria_node::oval_criteria_node_get_type (struct oval_criteria_node *)
| Returns attribute Oval_criteria_node->type.
OSCAP_API bool | oval_criteria_node::oval_criteria_node_get_negate (struct oval_criteria_node *)
| Returns attribute Oval_criteria_node->negate.
OSCAP_API bool | oval_criteria_node::oval_criteria_node_get_applicability_check (struct oval_criteria_node *)
| Returns attribute Oval_criteria_node->applicability_check.
OSCAP_API char * | oval_criteria_node::oval_criteria_node_get_comment (struct oval_criteria_node *)
| Returns attribute Oval_criteria_node->comment.
OSCAP_API oval_operator_t | oval_criteria_node::oval_criteria_node_get_operator (struct oval_criteria_node *)
| Returns attribute Oval_criteria->operator HOWDI.
OSCAP_API struct oval_criteria_node_iterator * | oval_criteria_node::oval_criteria_node_get_subnodes (struct oval_criteria_node *)
| Returns attribute Oval_criteria_node->subnodes.
OSCAP_API struct oval_test * | oval_criteria_node::oval_criteria_node_get_test (struct oval_criteria_node *)
| Returns attribute Oval_criterion->test.
OSCAP_API struct oval_definition * | oval_criteria_node::oval_criteria_node_get_definition (struct oval_criteria_node *)
| Returns attribute Oval_extends->definition.
OSCAP_API char * | oval_object_content::oval_object_content_get_field_name (struct oval_object_content *)
| Get field name of a object content.
OSCAP_API oval_object_content_type_t | oval_object_content::oval_object_content_get_type (struct oval_object_content *)
| Get type of a object content (entity or set).
OSCAP_API struct oval_entity * | oval_object_content::oval_object_content_get_entity (struct oval_object_content *)
| Get entity of a simple object content.
OSCAP_API oval_check_t | oval_object_content::oval_object_content_get_varCheck (struct oval_object_content *)
| Get varCheck of a simple object content.
OSCAP_API struct oval_setobject * | oval_object_content::oval_object_content_get_setobject (struct oval_object_content *)
| Get setobject of a set object content.
OSCAP_API struct oval_filter * | oval_object_content::oval_object_content_get_filter (struct oval_object_content *content)
| Get filter of a set object content.
OSCAP_API char * | oval_behavior::oval_behavior_get_key (struct oval_behavior *)
| Get OVAL behavior name.
OSCAP_API char * | oval_behavior::oval_behavior_get_value (struct oval_behavior *)
| Get OVAL behavior value.
OSCAP_API struct oval_entity * | oval_state_content::oval_state_content_get_entity (struct oval_state_content *)
| Get entity of a state content.
OSCAP_API struct oval_record_field_iterator * | oval_state_content::oval_state_content_get_record_fields (struct oval_state_content *)
OSCAP_API oval_check_t | oval_state_content::oval_state_content_get_var_check (struct oval_state_content *)
| Get multipe variable values processing of a state content.
OSCAP_API oval_check_t | oval_state_content::oval_state_content_get_ent_check (struct oval_state_content *)
| Get multipe entities processing of a state content.
OSCAP_API oval_existence_t | oval_state_content::oval_state_content_get_check_existence (struct oval_state_content *content)
| Get "check_existence" attribute of an OVAL state entity.
OSCAP_API oval_datatype_t | oval_value::oval_value_get_datatype (struct oval_value *)
| Get OVAL value datatype.
OSCAP_API char * | oval_value::oval_value_get_text (struct oval_value *)
| Get OVAL value as a text.
OSCAP_API unsigned char * | oval_value::oval_value_get_binary (struct oval_value *)
| Get OVAL value as a piece of raw binary data.
OSCAP_API bool | oval_value::oval_value_get_boolean (struct oval_value *)
| Get OVAL value as a boolean.
OSCAP_API float | oval_value::oval_value_get_float (struct oval_value *)
| Get OVAL value as a floating point number.
OSCAP_API long long | oval_value::oval_value_get_integer (struct oval_value *)
| Get OVAL value as an integer.
OSCAP_API char * | oval_entity::oval_entity_get_name (struct oval_entity *)
| Get OVAL entity name.
OSCAP_API oval_entity_type_t | oval_entity::oval_entity_get_type (struct oval_entity *)
| Get OVAL entity type.
OSCAP_API oval_datatype_t | oval_entity::oval_entity_get_datatype (struct oval_entity *)
| Get OVAL entity datatype.
OSCAP_API oval_operation_t | oval_entity::oval_entity_get_operation (struct oval_entity *)
| Get OVAL entity operation type.
OSCAP_API struct oval_variable * | oval_entity::oval_entity_get_variable (struct oval_entity *)
| Get OVAL entity varref variable.
OSCAP_API struct oval_value * | oval_entity::oval_entity_get_value (struct oval_entity *)
| Get OVAL entity value.
OSCAP_API int | oval_entity::oval_entity_get_mask (struct oval_entity *)
| Get OVAL entity mask.
OSCAP_API oval_entity_varref_type_t | oval_entity::oval_entity_get_varref_type (struct oval_entity *)
| Get OVAL entity varref type.
OSCAP_API oval_record_field_type_t | oval_record_field::oval_record_field_get_type (struct oval_record_field *)
OSCAP_API char * | oval_record_field::oval_record_field_get_name (struct oval_record_field *)
OSCAP_API char * | oval_record_field::oval_record_field_get_value (struct oval_record_field *)
OSCAP_API oval_datatype_t | oval_record_field::oval_record_field_get_datatype (struct oval_record_field *)
OSCAP_API int | oval_record_field::oval_record_field_get_mask (struct oval_record_field *)
OSCAP_API oval_operation_t | oval_record_field::oval_record_field_get_operation (struct oval_record_field *)
OSCAP_API struct oval_variable * | oval_record_field::oval_record_field_get_variable (struct oval_record_field *)
OSCAP_API oval_check_t | oval_record_field::oval_record_field_get_var_check (struct oval_record_field *)
OSCAP_API oval_check_t | oval_record_field::oval_record_field_get_ent_check (struct oval_record_field *)
OSCAP_API struct oval_state * | oval_filter::oval_filter_get_state (struct oval_filter *)
OSCAP_API oval_filter_action_t | oval_filter::oval_filter_get_filter_action (struct oval_filter *)
OSCAP_API oval_setobject_type_t | oval_setobject::oval_setobject_get_type (struct oval_setobject *)
| Get OVAL set object type.
OSCAP_API oval_setobject_operation_t | oval_setobject::oval_setobject_get_operation (struct oval_setobject *)
| Get OVAL set object operation type.
OSCAP_API struct oval_setobject_iterator * | oval_setobject::oval_setobject_get_subsets (struct oval_setobject *)
| Get OVAL set object subsets.
OSCAP_API struct oval_object_iterator * | oval_setobject::oval_setobject_get_objects (struct oval_setobject *)
| Get OVAL set object referenced objects.
OSCAP_API struct oval_filter_iterator * | oval_setobject::oval_setobject_get_filters (struct oval_setobject *)
| Get OVAL set object filters.
OSCAP_API oval_component_type_t | oval_component::oval_component_get_type (struct oval_component *)
| Returns attribute Oval_component->type.
OSCAP_API struct oval_object * | oval_component::oval_component_get_object (struct oval_component *)
| Returns attribute Oval_component_object->object.
OSCAP_API char * | oval_component::oval_component_get_item_field (struct oval_component *)
| Returns attribute Oval_component_object->item_field.
OSCAP_API char * | oval_component::oval_component_get_record_field (struct oval_component *)
| Returns attribute Oval_component_object->record_field.
OSCAP_API struct oval_variable * | oval_component::oval_component_get_variable (struct oval_component *)
| Returns attribute Oval_component_variable->variable.
OSCAP_API struct oval_component_iterator * | oval_component::oval_component_get_function_components (struct oval_component *)
| Returns attribute Oval_function->components.
OSCAP_API oval_arithmetic_operation_t | oval_component::oval_component_get_arithmetic_operation (struct oval_component *)
| Returns attribute Oval_function_ARITHMETIC->arithmetic_operation.
OSCAP_API char * | oval_component::oval_component_get_prefix (struct oval_component *)
| Returns attribute Oval_function_BEGIN->prefix.
OSCAP_API char * | oval_component::oval_component_get_suffix (struct oval_component *)
| Returns attribute Oval_function_END->suffix.
OSCAP_API char * | oval_component::oval_component_get_split_delimiter (struct oval_component *)
| Returns attribute Oval_function_SPLIT->delimiter.
OSCAP_API bool | oval_component::oval_component_get_glob_to_regex_glob_noescape (struct oval_component *)
| Returns attribute Oval_function_GLOB_TO_REGEX->glob_noescape.
OSCAP_API int | oval_component::oval_component_get_substring_start (struct oval_component *)
| Returns attribute Oval_function_SUBSTRING->start.
OSCAP_API int | oval_component::oval_component_get_substring_length (struct oval_component *)
| Returns attribute Oval_function_SUBSTRING->length.
OSCAP_API oval_datetime_format_t | oval_component::oval_component_get_timedif_format_1 (struct oval_component *)
| Returns attribute Oval_function_TIMEDIF->timedif_format_1.
OSCAP_API oval_datetime_format_t | oval_component::oval_component_get_timedif_format_2 (struct oval_component *)
| Returns attribute Oval_function_TIMEDIF->timedif_format_2.
OSCAP_API char * | oval_component::oval_component_get_regex_pattern (struct oval_component *)
| Returns attribute Oval_function_REGEX_CAPTURE->pattern.
OSCAP_API struct oval_value * | oval_component::oval_component_get_literal_value (struct oval_component *)
| Returns attribute Oval_literal->literal.

## Iterators

OSCAP_API bool | oval_definition_iterator::oval_definition_iterator_has_more (struct oval_definition_iterator *)
| Returns true if the iterator contains more instances of oval_definition.
OSCAP_API struct oval_definition * | oval_definition_iterator::oval_definition_iterator_next (struct oval_definition_iterator *)
| Returns the next iterated instance of oval_definition.
OSCAP_API void | oval_definition_iterator::oval_definition_iterator_free (struct oval_definition_iterator *)
| Free the iterator.
OSCAP_API bool | oval_test_iterator::oval_test_iterator_has_more (struct oval_test_iterator *)
| Returns true if the iterator is not exhausted.
OSCAP_API struct oval_test * | oval_test_iterator::oval_test_iterator_next (struct oval_test_iterator *)
| Returns the next instance of oval_test.
OSCAP_API void | oval_test_iterator::oval_test_iterator_free (struct oval_test_iterator *)
| Frees the iterator.
OSCAP_API bool | oval_object_iterator::oval_object_iterator_has_more (struct oval_object_iterator *)
| Returns true if the iterator is not exhausted.
OSCAP_API struct oval_object * | oval_object_iterator::oval_object_iterator_next (struct oval_object_iterator *)
| Returns the next instance of oval_object.
OSCAP_API void | oval_object_iterator::oval_object_iterator_free (struct oval_object_iterator *)
| Frees the iterator.
OSCAP_API bool | oval_state_iterator::oval_state_iterator_has_more (struct oval_state_iterator *)
| Returns true if the iterator is not exhausted.
OSCAP_API struct oval_state * | oval_state_iterator::oval_state_iterator_next (struct oval_state_iterator *)
| Returns the next instance of oval_state.
OSCAP_API void | oval_state_iterator::oval_state_iterator_free (struct oval_state_iterator *)
| Frees the iterator.
OSCAP_API bool | oval_variable_iterator::oval_variable_iterator_has_more (struct oval_variable_iterator *)
| Returns true if iterator not exhausted.
OSCAP_API struct oval_variable * | oval_variable_iterator::oval_variable_iterator_next (struct oval_variable_iterator *)
| Returns next instance of oval_variable.
OSCAP_API void | oval_variable_iterator::oval_variable_iterator_free (struct oval_variable_iterator *)
| Free iterator.
OSCAP_API bool | oval_affected_iterator::oval_affected_iterator_has_more (struct oval_affected_iterator *)
| Return true if iterator has more oval_affected.
OSCAP_API struct oval_affected * | oval_affected_iterator::oval_affected_iterator_next (struct oval_affected_iterator *)
| Return next instance of oval_affected from iterator.
OSCAP_API void | oval_affected_iterator::oval_affected_iterator_free (struct oval_affected_iterator *)
| Release instance of oval_affected_ iterator.
OSCAP_API bool | oval_reference_iterator::oval_reference_iterator_has_more (struct oval_reference_iterator *)
OSCAP_API struct oval_reference * | oval_reference_iterator::oval_reference_iterator_next (struct oval_reference_iterator *)
OSCAP_API void | oval_reference_iterator::oval_reference_iterator_free (struct oval_reference_iterator *)
OSCAP_API bool | oval_criteria_node_iterator::oval_criteria_node_iterator_has_more (struct oval_criteria_node_iterator *)
| Returns true if the iterator is not exhausted.
OSCAP_API struct oval_criteria_node * | oval_criteria_node_iterator::oval_criteria_node_iterator_next (struct oval_criteria_node_iterator *)
| Returns the next instance of Oval_criteria_node from the iterator.
OSCAP_API void | oval_criteria_node_iterator::oval_criteria_node_iterator_free (struct oval_criteria_node_iterator *)
| Free the iterator.
OSCAP_API bool | oval_object_content_iterator::oval_object_content_iterator_has_more (struct oval_object_content_iterator *)
OSCAP_API struct oval_object_content * | oval_object_content_iterator::oval_object_content_iterator_next (struct oval_object_content_iterator *)
OSCAP_API void | oval_object_content_iterator::oval_object_content_iterator_free (struct oval_object_content_iterator *)
OSCAP_API bool | oval_behavior_iterator::oval_behavior_iterator_has_more (struct oval_behavior_iterator *)
OSCAP_API struct oval_behavior * | oval_behavior_iterator::oval_behavior_iterator_next (struct oval_behavior_iterator *)
OSCAP_API void | oval_behavior_iterator::oval_behavior_iterator_free (struct oval_behavior_iterator *)
OSCAP_API bool | oval_state_content_iterator::oval_state_content_iterator_has_more (struct oval_state_content_iterator *)
OSCAP_API struct oval_state_content * | oval_state_content_iterator::oval_state_content_iterator_next (struct oval_state_content_iterator *)
OSCAP_API void | oval_state_content_iterator::oval_state_content_iterator_free (struct oval_state_content_iterator *)
OSCAP_API bool | oval_value_iterator::oval_value_iterator_has_more (struct oval_value_iterator *)
OSCAP_API struct oval_value * | oval_value_iterator::oval_value_iterator_next (struct oval_value_iterator *)
OSCAP_API int | oval_value_iterator::oval_value_iterator_remaining (struct oval_value_iterator *iterator)
OSCAP_API void | oval_value_iterator::oval_value_iterator_free (struct oval_value_iterator *)
OSCAP_API bool | oval_entity_iterator::oval_entity_iterator_has_more (struct oval_entity_iterator *)
OSCAP_API struct oval_entity * | oval_entity_iterator::oval_entity_iterator_next (struct oval_entity_iterator *)
OSCAP_API void | oval_entity_iterator::oval_entity_iterator_free (struct oval_entity_iterator *)
OSCAP_API bool | oval_record_field::oval_record_field_iterator_has_more (struct oval_record_field_iterator *)
OSCAP_API struct oval_record_field * | oval_record_field::oval_record_field_iterator_next (struct oval_record_field_iterator *)
OSCAP_API void | oval_record_field::oval_record_field_iterator_free (struct oval_record_field_iterator *)
OSCAP_API bool | oval_filter::oval_filter_iterator_has_more (struct oval_filter_iterator *)
OSCAP_API struct oval_filter * | oval_filter::oval_filter_iterator_next (struct oval_filter_iterator *)
OSCAP_API void | oval_filter::oval_filter_iterator_free (struct oval_filter_iterator *)
OSCAP_API bool | oval_component_iterator::oval_component_iterator_has_more (struct oval_component_iterator *)
| Return true if the iterator is not exhausted.
OSCAP_API struct oval_component * | oval_component_iterator::oval_component_iterator_next (struct oval_component_iterator *)
| return the next instance of Oval_component.
OSCAP_API void | oval_component_iterator::oval_component_iterator_free (struct oval_component_iterator *)
| Free the iterator.
OSCAP_API int | oval_component_iterator::oval_component_iterator_remaining (struct oval_component_iterator *)
| How many remains.

## Detailed Description

Interface for Definition model.

Class diagram

## Enumeration Type Documentation

## oval_affected_family_t

enum oval_affected_family_t

Affected family enumeration.

Since new family values can only be added with new version of the schema, the value OVAL_AFCFML_UNDEFINED is to be used when the desired family is not available

## Function Documentation

## oval_affected_clone()

OSCAP_API struct oval_affected * oval_affected_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_affected * | old_affected )

Clone instance of oval_affected.

Returns
  A copy of the specified oval_affected.

## oval_affected_get_family()

OSCAP_API oval_affected_family_t oval_affected_get_family | ( | struct oval_affected * |  | ) |

Get member value oval_affected family.

Note
  A family value of OVAL_AFCFML_UNDEFINED signifies some family other than one of the defined values is targeted.

## oval_affected_get_platforms()

OSCAP_API struct oval_string_iterator * oval_affected_get_platforms | ( | struct oval_affected * |  | ) |

Get member values oval_affected platform_names.

If the returned iterator is empty, then the associated Oval_definition is not constrained to a specific platform choice.

Returns
  A new iterator for the platforms attribute of the specified oval_affected. It should be freed after use by the calling application.

## oval_affected_get_products()

OSCAP_API struct oval_string_iterator * oval_affected_get_products | ( | struct oval_affected * |  | ) |

Get member values oval_affected product_names.

If the returned iterator is empty, then the associated Oval_definition is not constrained to a specific product choice.

Returns
  A new iterator for the products attribute of the specified oval_affected. It should be freed after use by the calling application.

## oval_behavior_clone()

OSCAP_API struct oval_behavior * oval_behavior_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_behavior * | old_behavior )

Returns
  A copy of the specified oval_behavior.

## oval_behavior_get_key()

OSCAP_API char * oval_behavior_get_key | ( | struct oval_behavior * |  | ) |

Get OVAL behavior name.

Returns
  A pointer to the key attribute of the specified oval_behavior.

## oval_behavior_get_value()

OSCAP_API char * oval_behavior_get_value | ( | struct oval_behavior * |  | ) |

Get OVAL behavior value.

Returns
  A pointer to the value attribute of the specified oval_behavior.

## oval_component_clone()

OSCAP_API struct oval_component * oval_component_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_component * | old_component )

Clone instance of Oval_component.

Returns
  A copy of the specified oval_component.

## oval_component_get_arithmetic_operation()

OSCAP_API oval_arithmetic_operation_t oval_component_get_arithmetic_operation | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_ARITHMETIC->arithmetic_operation.

IF component->type <> OVAL_FUNCTION_ARITHMETIC, this method shall return OVAL_ARITHMETIC_UNKNOWN.

## oval_component_get_function_components()

OSCAP_API struct oval_component_iterator * oval_component_get_function_components | ( | struct oval_component * |  | ) |

Returns attribute Oval_function->components.

IF component->type < OVAL_COMPONENT_FUNCTION, this method shall return NULL.

Returns
  A new iterator for the function_components attribute of the specified oval_component. It should be freed after use by the calling application.

## oval_component_get_glob_to_regex_glob_noescape()

OSCAP_API bool oval_component_get_glob_to_regex_glob_noescape | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_GLOB_TO_REGEX->glob_noescape.

IF component->type <> OVAL_FUNCTION_GLOB_TO_REGEX, this method shall return false

Returns
  An attribute of the specified oval_component.

## oval_component_get_item_field()

OSCAP_API char * oval_component_get_item_field | ( | struct oval_component * |  | ) |

Returns attribute Oval_component_object->item_field.

Returns
  A pointer to the item_field attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_literal_value()

OSCAP_API struct oval_value * oval_component_get_literal_value | ( | struct oval_component * |  | ) |

Returns attribute Oval_literal->literal.

IF component->type <> OVAL_COMPONENT_LITERAL, this method shall return NULL

Returns
  A pointer to the value attribute of the specified oval_component.

Note
  applications should not free the Oval_value returned by this method

## oval_component_get_object()

OSCAP_API struct oval_object * oval_component_get_object | ( | struct oval_component * |  | ) |

Returns attribute Oval_component_object->object.

IF component->type <> OVAL_COMPONENT_OBJECTREF, this method shall return NULL.

Returns
  A pointer to the object attribute of the specified oval_component.

Note
  applications should not free the Oval_object returned by this method

## oval_component_get_prefix()

OSCAP_API char * oval_component_get_prefix | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_BEGIN->prefix.

IF component->type <> OVAL_FUNCTION_BEGIN, this method shall return NULL

Returns
  A pointer to the attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_record_field()

OSCAP_API char * oval_component_get_record_field | ( | struct oval_component * |  | ) |

Returns attribute Oval_component_object->record_field.

Returns
  A pointer to the record_field attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_regex_pattern()

OSCAP_API char * oval_component_get_regex_pattern | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_REGEX_CAPTURE->pattern.

IF component->type <> OVAL_FUNCTION_REGEX_CAPTURE, this method shall return NULL

Returns
  A pointer to the attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_split_delimiter()

OSCAP_API char * oval_component_get_split_delimiter | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_SPLIT->delimiter.

IF component->type <> OVAL_FUNCTION_SPLIT, this method shall return NULL

Returns
  A pointer to the attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_substring_length()

OSCAP_API int oval_component_get_substring_length | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_SUBSTRING->length.

IF component->type <> OVAL_FUNCTION_SUBSTRING, this method shall return 0

## oval_component_get_substring_start()

OSCAP_API int oval_component_get_substring_start | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_SUBSTRING->start.

IF component->type <> OVAL_FUNCTION_SUBSTRING, this method shall return 0

## oval_component_get_suffix()

OSCAP_API char * oval_component_get_suffix | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_END->suffix.

IF component->type <> OVAL_FUNCTION_END, this method shall return NULL

Returns
  A pointer to the attribute of the specified oval_component.

Note
  applications should not free the char* returned by this method

## oval_component_get_timedif_format_1()

OSCAP_API oval_datetime_format_t oval_component_get_timedif_format_1 | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_TIMEDIF->timedif_format_1.

IF component->type <> OVAL_FUNCTION_TIMEDIF, this method shall return OVAL_TIMEDATE_UNKNOWN

## oval_component_get_timedif_format_2()

OSCAP_API oval_datetime_format_t oval_component_get_timedif_format_2 | ( | struct oval_component * |  | ) |

Returns attribute Oval_function_TIMEDIF->timedif_format_2.

IF component->type <> OVAL_FUNCTION_TIMEDIF, this method shall return OVAL_TIMEDATE_UNKNOWN

## oval_component_get_variable()

OSCAP_API struct oval_variable * oval_component_get_variable | ( | struct oval_component * |  | ) |

Returns attribute Oval_component_variable->variable.

IF component->type <> OVAL_COMPONENT_VARREF, this method shall return NULL.

Returns
  A pointer to the variable attribute of the specified oval_component.

Note
  applications should not free the Oval_variable returned by this method

## oval_component_iterator_next()

OSCAP_API struct oval_component * oval_component_iterator_next | ( | struct oval_component_iterator * |  | ) |

return the next instance of Oval_component.

If the iterator is exhausted this method shall return NULL.

## oval_component_new()

OSCAP_API struct oval_component * oval_component_new | ( | struct oval_definition_model * | ,
|  | oval_component_type_t | type )

Construct new intance of Oval_component.

Attribute values shall be initialized:

- type – initialized to the value of the type parameter.
- If type == OVAL_FUNCTION_CONCAT
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_COUNT
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_ESCAPE_REGEX
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_ARITHMETIC
  - arithmetic_operation – initialized to OVAL_ARITHMETIC_UNKNOWN
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_BEGIN
  - prefix – initialized to NULL
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_END
  - suffix – initialized to NULL
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_SPLIT
  - delimiter – initialized to NULL
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_SUBSTRING
  - start, length – initialized to zero
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_TIMEDIF
  - timedif_format_1, timedif_format_2 – initialized to OVAL_DATETIME_UNKNOWN
  - components – initialized to empty iterator
- If type == OVAL_FUNCTION_REGEX_CAPTURE
  - pattern – initialized to NULL
  - components – initialized to empty iterator
- If type == OVAL_COMPONENT_LITERAL
  - literal – initialized to NULL
- If type == OVAL_COMPONENT_OBJECTREF
  - object – initialized to NULL
  - object_field – initialized to NULL
- If type == OVAL_COMPONENT_VARREF
  - variable – initialized to NULL

This method shall not construct a new instance of Oval_object and shall return NULL if the type parameter is entered as OVAL_COMPONENT_UNKNOWN.

Parameters

  type | - the required component type.

## oval_component_set_object()

OSCAP_API void oval_component_set_object | ( | struct oval_component * | ,
|  | struct oval_object * | object )

set attribute Oval_component_object->object.

IF component->type <> OVAL_COMPONENT_OBJECTREF OR component->object <> NULL, this method does nothing .

## oval_component_set_variable()

OSCAP_API void oval_component_set_variable | ( | struct oval_component * | ,
|  | struct oval_variable * | variable )

set attribute Oval_component_object->variable.

IF component->type <> OVAL_COMPONENT_OBJECTREF OR component->variable <> NULL, this method does nothing.

## oval_criteria_node_add_subnode()

OSCAP_API void oval_criteria_node_add_subnode | ( | struct oval_criteria_node * | ,
|  | struct oval_criteria_node * | node )

Append instance of Oval_criteria_node to attribute Oval_criteria->subnodes.

If Oval_criteria_node->type <> OVAL_NODETYPE_CRITERIA, this method shall return without changing the Oval_criteria_node state.

Note
  Instances of Oval_criteria_node bound to an Oval_criteria by this method should not be subsequently freed by the application using oval_criteria_node_free. These instances shall be freed by the API when the Oval_criteria is freed.
  An application should not bind a given Oval_criteria_node as a subnode to more than one Oval_criteria, nor should a given Oval_criteria_node be bound more than once to a single Oval_criteria.

Parameters

  - | (Not NULL) the subnode to be appended.

## oval_criteria_node_clone()

OSCAP_API struct oval_criteria_node * oval_criteria_node_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_criteria_node * | old_node )

Clone an instance of oval_criteria_node.

Returns
  A copy of the specified oval_criteria_node.

## oval_criteria_node_get_comment()

OSCAP_API char * oval_criteria_node_get_comment | ( | struct oval_criteria_node * |  | ) |

Returns attribute Oval_criteria_node->comment.

Returns
  A pointer to the comment attribute of the specified oval_criteria_node.

## oval_criteria_node_get_definition()

OSCAP_API struct oval_definition * oval_criteria_node_get_definition | ( | struct oval_criteria_node * |  | ) |

Returns attribute Oval_extends->definition.

If Oval_criteria_node->type <> OVAL_NODETYPE_EXTENDDEF, this method shall return NULL.

Returns
  A pointer to the definition attribute of the specified oval_criteria_node.

## oval_criteria_node_get_operator()

OSCAP_API oval_operator_t oval_criteria_node_get_operator | ( | struct oval_criteria_node * |  | ) |

Returns attribute Oval_criteria->operator HOWDI.

Note
  If Oval_criteria_node->type <> OVAL_NODETYPE_CRITERIA, this method shall return OVAL_OPERATOR_UNKNOWN.

## oval_criteria_node_get_subnodes()

OSCAP_API struct oval_criteria_node_iterator * oval_criteria_node_get_subnodes | ( | struct oval_criteria_node * |  | ) |

Returns attribute Oval_criteria_node->subnodes.

If Oval_criteria_node->type <> OVAL_NODETYPE_CRITERIA, this method shall return NULL.

Returns
  A new iterator for the subnodes attribute of the specified oval_criteria_node. It should be freed after use by the calling application.

## oval_criteria_node_get_test()

OSCAP_API struct oval_test * oval_criteria_node_get_test | ( | struct oval_criteria_node * |  | ) |

Returns attribute Oval_criterion->test.

If Oval_criteria_node->type <> OVAL_NODETYPE_CRITERION, this method shall return NULL.

Returns
  A pointer to the test attribute of the specified oval_criteria_node.

## oval_criteria_node_iterator_next()

OSCAP_API struct oval_criteria_node * oval_criteria_node_iterator_next | ( | struct oval_criteria_node_iterator * |  | ) |

Returns the next instance of Oval_criteria_node from the iterator.

Returns NULL if the iterator is exhausted.

## oval_criteria_node_new()

OSCAP_API struct oval_criteria_node * oval_criteria_node_new | ( | struct oval_definition_model * | ,
|  | oval_criteria_node_type_t | type )

Construct an instance of oval_criteria_node.

Initialized attribute values are:

- type initialized to value of type parameter.

negate – initialized to false

- comment – initialized to NULL
- If type == OVAL_NODETYPE_CRITERIA (Oval_criteria):
  - operator – initialized to OVAL_OPERATOR_UNKNOWN
  - subnodes – initialized to empty iterator
- If type == OVAL_NODETYPE_CRITERION (Oval_criterion):
  - test – initialized to NULL
- If type == OVAL_NODETYPE_EXTENDDEF (Oval_extends):
  - definition – initialized to NULL Careful ! Calling this function with inappropriate number of arguments will cause undefined behavior !

If the type parameter is entered as OVAL_NODETYPE_UNKNOWN, no instance shall be constructed and the method shall return NULL.

Parameters

  type | - the required node type.

## oval_criteria_node_set_applicability_check()

OSCAP_API void oval_criteria_node_set_applicability_check | ( | struct oval_criteria_node * | ,
|  | bool | applicability_check )

Set attribute Oval_criteria_node->applicability_check.

Parameters

  applicability_check | - the required value of the applicability_check attribute

## oval_criteria_node_set_comment()

OSCAP_API void oval_criteria_node_set_comment | ( | struct oval_criteria_node * | ,
|  | char * | comment )

set attribute Oval_criteria_node->comment.

Parameters

  comm | - (Not NULL) a copy of the comment parameter is set as the comment attribute.

## oval_criteria_node_set_definition()

OSCAP_API void oval_criteria_node_set_definition | ( | struct oval_criteria_node * | ,
|  | struct oval_definition * | )

Sets attribute Oval_extends->definition.

If Oval_criteria_node->type == OVAL_NODETYPE_EXTENDDEF and the value of the definition attribute is NULL, this method shall overwrite the definition attribute value with the definition parameter. Otherwise the Oval_criteria_node state shall not be changed by this method.

## oval_criteria_node_set_negate()

OSCAP_API void oval_criteria_node_set_negate | ( | struct oval_criteria_node * | ,
|  | bool | negate )

Set attribute Oval_criteria_node->negate.

Parameters

  negate | - the required value of the negate attribute

## oval_criteria_node_set_operator()

OSCAP_API void oval_criteria_node_set_operator | ( | struct oval_criteria_node * | ,
|  | oval_operator_t | op )

Set attribute Oval_criteria->operator.

If Oval_criteria_node->type == OVAL_NODETYPE_CRITERIA and the value of the operator attribute is OVAL_OPERATOR_UNKNOWN, this method shall overwrite the operator attribute value with the operator parameter. Otherwise the Oval_criteria_node state shall not be changed by this method.

## oval_criteria_node_set_test()

OSCAP_API void oval_criteria_node_set_test | ( | struct oval_criteria_node * | ,
|  | struct oval_test * | )

Sets attribute Oval_criterion->test.

If Oval_criteria_node->type == OVAL_NODETYPE_CRITERION and the value of the test attribute is NULL, this method shall overwrite the test attribute value with the test parameter. Otherwise the Oval_criteria_node state shall not be changed by this method.

## oval_criteria_set_node_type()

OSCAP_API void oval_criteria_set_node_type | ( | struct oval_criteria_node * | node,
|  | oval_criteria_node_type_t | type )

Set attribute Oval_criteria_node->type.

Parameters

  type | - the required value of the type attribute

## oval_definition_add_affected()

OSCAP_API void oval_definition_add_affected | ( | struct oval_definition * | ,
|  | struct oval_affected * | affected )

Append instance of oval_affected to attribute oval_definition->affected.

Note
  Instances of Oval_affected bound to Oval_definition by this method should not be subsequently freed by the application using oval_affected_free. These instances shall be freed by the API when the Oval_definition is freed.
  A given instance of Oval_affected should not be appended by an application to more than one instance of Oval_definition, nor should the given instance of Oval_affected be appended more than once to a single instance of Oval_definition.

Parameters

  affected | - appended instance of Oval_affected.

## oval_definition_add_note()

OSCAP_API void oval_definition_add_note | ( | struct oval_definition * | ,
|  | char * | note )

Append a copy of the note parameter to attribute Oval_definition->notes.

Parameters

  note | - the note text.

## oval_definition_add_reference()

OSCAP_API void oval_definition_add_reference | ( | struct oval_definition * | ,
|  | struct oval_reference * | reference )

Append instance of oval_reference to attribute oval_definition->references.

Note
  Instances of Oval_reference bound to Oval_definition by this method should not be subsequently freed by the application using oval_reference_free. These instances shall be freed by the API when the Oval_definition is freed.
  A given instance of Oval_reference should not be appended by an application to more than one instance of Oval_definition, nor should the given instance of Oval_reference be appended more than once to a single instance of Oval_definition.

Parameters

  reference | - appended instance of Oval_reference.

## oval_definition_clone()

OSCAP_API struct oval_definition * oval_definition_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_definition * | old_definition )

Clone instance of oval_definition and add it to the specified oval_definition_model.

Returns
  A copy of the specified oval_definition.

## oval_definition_free()

OSCAP_API void oval_definition_free | ( | struct oval_definition * |  | ) |

Release an instance of oval_definition.

All attributes of the Oval_definition are also released.

Note
  Applications should not call this method to free an Oval_definition that is bound to an instance of OVALDEF. These bound definitions are released when the OVALDEF are released.

## oval_definition_get_affected()

OSCAP_API struct oval_affected_iterator * oval_definition_get_affected | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->affected.

Returns
  A new iterator for the affected attribute of the specified oval_definition. It should be freed after use by the calling application.

## oval_definition_get_criteria()

OSCAP_API struct oval_criteria_node * oval_definition_get_criteria | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->criteria.

Returns
  A pointer to the criteria attribute of the specified oval_definition.

## oval_definition_get_description()

OSCAP_API char * oval_definition_get_description | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->description.

Returns
  A pointer to the description attribute of the specified oval_definition.

## oval_definition_get_notes()

OSCAP_API struct oval_string_iterator * oval_definition_get_notes | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->notes.

Returns
  A new iterator for the notes attribute of the specified oval_definition. It should be freed after use by the calling application.

## oval_definition_get_references()

OSCAP_API struct oval_reference_iterator * oval_definition_get_references | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->references.

Returns
  A new iterator for the reference attribute of the specified oval_definition. It should be freed after use by the calling application.

## oval_definition_get_title()

OSCAP_API char * oval_definition_get_title | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->title.

Returns
  A pointer to the title attribute of the specified oval_definition.

## oval_definition_get_version()

OSCAP_API int oval_definition_get_version | ( | struct oval_definition * |  | ) |

Returns attribute oval_definition->version.

Returns
  A pointer to the id attribute of the specified oval_definition.

## oval_definition_iterator_next()

OSCAP_API struct oval_definition * oval_definition_iterator_next | ( | struct oval_definition_iterator * |  | ) |

Returns the next iterated instance of oval_definition.

NULL is returned if the iterator is exhausted (oval_definition_iterator_has_more == false)

## oval_definition_model_bind_variable_model()

OSCAP_API int oval_definition_model_bind_variable_model | ( | struct oval_definition_model * | ,
|  | struct oval_variable_model * | )

Bind an oval_variable_model to the specified oval_definition_model.

Returns
  zero on success or non zero value if an error occurred

## oval_definition_model_clone()

OSCAP_API struct oval_definition_model * oval_definition_model_clone | ( | struct oval_definition_model * |  | ) |

Copy an oval_definition_model.

Returns
  A copy of the specified oval_definition_model.

## oval_definition_model_get_definition()

OSCAP_API struct oval_definition * oval_definition_model_get_definition | ( | struct oval_definition_model * | ,
|  | const char * | id )

Returns the appended oval_definition having the specified id.

IF the specified id does not resolve to an appended Oval_definition the method shall return NULL.

See also
  oval_definition_add_definition

Parameters

  id | the definition id.

## oval_definition_model_get_object()

OSCAP_API struct oval_object * oval_definition_model_get_object | ( | struct oval_definition_model * | model,
|  | const char * | id )

Get OVAL object by ID.

Return a designated oval_object from the specified oval_definition_model. If the specified id does not resolve to an oval_object the function returns NULL.

Parameters

  model | the queried model.
  id | the object id.

## oval_definition_model_get_objects()

OSCAP_API struct oval_object_iterator * oval_definition_model_get_objects | ( | struct oval_definition_model * | model | ) |

Get OVAL objects.

Return all oval_objects from the specified oval_definition_model.

Parameters

  model | the queried model.

## oval_definition_model_get_state()

OSCAP_API struct oval_state * oval_definition_model_get_state | ( | struct oval_definition_model * | model,
|  | const char * | id )

Get OVAL state by ID.

Return a designated oval_state from the specified oval_definition_model. If the specified id does not resolve to an oval_state the function returns NULL.

Parameters

  model | the queried model.
  id | the state id.

## oval_definition_model_get_states()

OSCAP_API struct oval_state_iterator * oval_definition_model_get_states | ( | struct oval_definition_model * | model | ) |

Get OVAL states.

Return all oval_states from the specified oval_definition_model.

Parameters

  model | the queried model.

## oval_definition_model_get_test()

OSCAP_API struct oval_test * oval_definition_model_get_test | ( | struct oval_definition_model * | model,
|  | const char * | id )

Get oval test by ID.

Return a designated oval_test from the specified oval_definition_model. If the specified id does not resolve to an oval_test the function returns NULL.

Parameters

  model | the queried model.
  id | the test id.

## oval_definition_model_get_tests()

OSCAP_API struct oval_test_iterator * oval_definition_model_get_tests | ( | struct oval_definition_model * | model | ) |

Get OVAL tests.

Return all oval_tests from the specified oval_definition_model.

Parameters

  model | the queried model.

## oval_definition_model_get_variable()

OSCAP_API struct oval_variable * oval_definition_model_get_variable | ( | struct oval_definition_model * | model,
|  | const char * | id )

Get OVAL variable by ID.

Return a designated oval_variable from the specified oval_definition_model. If the specified id does not resolve to an oval_variable the function returns NULL.

Parameters

  model | the queried model.
  id | the variable id.

## oval_definition_model_get_variable_models()

OSCAP_API struct oval_variable_model_iterator * oval_definition_model_get_variable_models | ( | struct oval_definition_model * |  | ) |

Return the list of variable models bound to the specified oval_definition_model.

Returns
  iterator over oval_variable_model collection

## oval_definition_model_get_variables()

OSCAP_API struct oval_variable_iterator * oval_definition_model_get_variables | ( | struct oval_definition_model * | model | ) |

Get OVAL variables.

Return all oval_variables from the specified oval_definition_model.

Parameters

  model | the queried model.

## oval_definition_model_import_source()

OSCAP_API struct oval_definition_model * oval_definition_model_import_source | ( | struct oscap_source * | source | ) |

Import the content of the oscap_source into the oval_definition_model.

Parameters

  source | The oscap_source to import from

Returns
  newly build oval_definition_model, or NULL if something went wrong

## oval_definition_model_supported()

OSCAP_API const char * oval_definition_model_supported | ( | void |  | ) |

Get supported version of OVAL XML.

Returns
  version of XML file format

## oval_definition_new()

OSCAP_API struct oval_definition * oval_definition_new | ( | struct oval_definition_model * | ,
|  | const char * | id )

Construct an instance of oval_definition.

Initialized attribute values are

- id bound to value specified by id parameter.

version bound to 0.

- class bound to OVAL_CLASS_UNKNOWN
- deprecated bound to false
- title bound to NULL
- description bound to NULL
- criteria bound to NULL
- affected bound to empty iterator
- references bound to empty iterator
- notes bound to empty iterator
  Parameters

    id | - (non-NULL) A copy of this string is bound to the id attribute of the created instance.

## oval_definition_set_class()

OSCAP_API void oval_definition_set_class | ( | struct oval_definition * | ,
|  | oval_definition_class_t | )

Set attribute oval_definition->class.

This method shall overwrite a OVAL_CLASS_UNKNOWN class attribute value with the value of the class parameter. Valid values of the class attribute shall not be overwritten by this method.

Parameters

  class | - the required class

## oval_definition_set_criteria()

OSCAP_API void oval_definition_set_criteria | ( | struct oval_definition * | ,
|  | struct oval_criteria_node * | criteria )

Set attribute oval_definition->criteria.

This method shall overwrite a NULL criteria attribute value with the criteria parameter only if the criteria parameter is an instance of Oval_criteria (i.e. criteria->type == OVAL_NODETYPE_CRITERIA). Other values of the criteria attribute shall not be overwritten by this method.

Note
  Instances of Oval_criteria bound to Oval_definition by this method should not be subsequently freed by the application using oval_criteria_node_free. These instances shall be freed by the API when the Oval_definition is freed.
  An application should not bind a given instance of Oval_criteria to more than one instance of Oval_definition, nor should a given instance of Oval_criteria be bound to both an Oval_definition and an Oval_criteria (using oval_criteria_node_add_subnode).

Parameters

  criteria | - the required instance of Oval_criteria

## oval_definition_set_deprecated()

OSCAP_API void oval_definition_set_deprecated | ( | struct oval_definition * | ,
|  | bool | deprecated )

Set attribute oval_definition->deprecated.

Parameters

  deprecated | - the required deprecation toggle.

## oval_definition_set_description()

OSCAP_API void oval_definition_set_description | ( | struct oval_definition * | ,
|  | char * | description )

Set attribute oval_definition->description.

This method shall overwrite a NULL description attribute value with a copy of the description parameter. Valid values of the description attribute shall not be overwritten by this method.

Parameters

  description | - the required description

## oval_definition_set_title()

OSCAP_API void oval_definition_set_title | ( | struct oval_definition * | ,
|  | char * | title )

Set attribute oval_definition->title.

This method shall overwrite a NULL title attribute value with a copy of the title parameter. Valid values of the title attribute shall not be overwritten by this method.

Parameters

  title | - the required title

## oval_definition_set_version()

OSCAP_API void oval_definition_set_version | ( | struct oval_definition * | ,
|  | int | version )

Set attribute oval_definition->version.

This method shall overwrite a zero version attribute value with the value of the version parameter. Valid values of the version attribute shall not be overwritten by this method.

Parameters

  version | - the required version

## oval_entity_clone()

OSCAP_API struct oval_entity * oval_entity_clone | ( | struct oval_definition_model * | model,
|  | struct oval_entity * | old_entity )

Returns
  A copy of the specified oval_entity.

## oval_entity_get_name()

OSCAP_API char * oval_entity_get_name | ( | struct oval_entity * |  | ) |

Get OVAL entity name.

Returns
  A pointer to the name attribute of the specified oval_entity.

## oval_entity_get_value()

OSCAP_API struct oval_value * oval_entity_get_value | ( | struct oval_entity * |  | ) |

Get OVAL entity value.

Returns
  A pointer to the value attribute of the specified oval_entity.

## oval_entity_get_variable()

OSCAP_API struct oval_variable * oval_entity_get_variable | ( | struct oval_entity * |  | ) |

Get OVAL entity varref variable.

Returns
  A pointer to the variable attribute of the specified oval_entity.

## oval_object_add_behavior()

OSCAP_API void oval_object_add_behavior | ( | struct oval_object * | ,
|  | struct oval_behavior * | behavior )

Append instance of oval_behavior to attribute oval_object->behaviors.

Oval_behaviors appended to a given Oval_object shall be freed by the API when the Oval_object is freed.

Note
  A specific instance of Oval_behavior should not be appended to more than one Oval_object, and an instance of Oval_behavior should not be appended more than once to a single Oval_object.
  An instance of Oval_behavior that is appended to an Oval_object should not be freed independently by the application using oval_behavior_free.

Parameters

  behavior | - (Not NULL) the Oval_behavior to be appended.

## oval_object_add_note()

OSCAP_API void oval_object_add_note | ( | struct oval_object * | ,
|  | char * | note )

Appends a copy of the note parameter to attribute oval_object->notes.

Parameters

  note | - (Not NULL) the text of the appended note.

## oval_object_add_object_content()

OSCAP_API void oval_object_add_object_content | ( | struct oval_object * | ,
|  | struct oval_object_content * | content )

Append instance of oval_object_content to attribute oval_object->object_contents.

Oval_object_contents appended to a given Oval_object shall be freed by the API when the Oval_object is freed.

Note
  A specific instance of Oval_object_content should not be appended to more than one Oval_object, and an instance of Oval_object_content should not be appended more than once to a single Oval_object.
  An instance of Oval_object_content that is appended to an Oval_object should not be freed independently by the application using oval_object_content_free.

Parameters

  content | - (Not NULL) the Oval_object_content to be appended.

## oval_object_clone()

OSCAP_API struct oval_object * oval_object_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_object * | old_object )

Clone instance of oval_object and add it to the specified oval_definition_model.

Returns
  A copy of the specified oval_object.

## oval_object_content_clone()

OSCAP_API struct oval_object_content * oval_object_content_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_object_content * | old_content )

Returns
  A copy of the specified oval_object_content.

## oval_object_content_get_entity()

OSCAP_API struct oval_entity * oval_object_content_get_entity | ( | struct oval_object_content * |  | ) |

Get entity of a simple object content.

Returns
  A pointer to the entity attribute of the specified oval_object_content.

## oval_object_content_get_field_name()

OSCAP_API char * oval_object_content_get_field_name | ( | struct oval_object_content * |  | ) |

Get field name of a object content.

Returns
  A pointer to the fieldName attribute of the specified oval_object_content.

## oval_object_content_get_filter()

OSCAP_API struct oval_filter * oval_object_content_get_filter | ( | struct oval_object_content * | content | ) |

Get filter of a set object content.

Returns
  A pointer to the filter attribute of the specified oval_object_content.

## oval_object_content_get_setobject()

OSCAP_API struct oval_setobject * oval_object_content_get_setobject | ( | struct oval_object_content * |  | ) |

Get setobject of a set object content.

Returns
  A pointer to the set attribute of the specified oval_object_content.

## oval_object_get_behaviors()

OSCAP_API struct oval_behavior_iterator * oval_object_get_behaviors | ( | struct oval_object * |  | ) |

Returns attribute oval_object->behaviors.

Returns
  A new iterator for the behaviors attribute of the specified oval_object. It should be freed after use by the calling application.

## oval_object_get_comment()

OSCAP_API char * oval_object_get_comment | ( | struct oval_object * |  | ) |

Returns attribute oval_object->comment.

Returns
  A pointer to the comment attribute of the specified oval_object.

## oval_object_get_id()

OSCAP_API char * oval_object_get_id | ( | struct oval_object * |  | ) |

Returns attribute oval_object->id.

Returns
  A pointer to the id attribute of the specified oval_object.

## oval_object_get_name()

OSCAP_API const char * oval_object_get_name | ( | struct oval_object * |  | ) |

Returns the name of an oval_object.

This is a convenience method that is equivalent to oval_subtype_get_text (oval_object_get_subtype)+"_object".

## oval_object_get_notes()

OSCAP_API struct oval_string_iterator * oval_object_get_notes | ( | struct oval_object * |  | ) |

Returns attribute oval_object->notes.

Returns
  A new iterator for the notes attribute of the specified oval_object. It should be freed after use by the calling application.

## oval_object_get_object_contents()

OSCAP_API struct oval_object_content_iterator * oval_object_get_object_contents | ( | struct oval_object * |  | ) |

Returns attribute oval_object->contents.

Returns
  A new iterator for the object_content attribute of the specified oval_object. It should be freed after use by the calling application.

## oval_object_new()

OSCAP_API struct oval_object * oval_object_new | ( | struct oval_definition_model * | ,
|  | const char * | id )

Construct new intance of oval_object.

Attribute values shall be initialized:

- family – initialized to OVAL_FAMILY_UNKNOWN
- subtype – initialized to OVAL_SUBTYPE_UNKNOWN
- notes – initialized to empty iterator
- comment – initialized to NULL
- id – initialized to a copy of the id parameter
- deprecated – initialized to false
- version – initialized to zero
- contents – initialized to empty iterator
- behaviors – initialized to empty iterator

Note
  This method shall not construct a new instance of Oval_object and shall return NULL if the text of the id parameter is not matched by the regular expression ^oval:[.A-Za-z0-9_-]+:obj:[1-9][0-9]*$.

Parameters

  id | - (Not NULL) the text of the required object id.

## oval_object_set_comment()

OSCAP_API void oval_object_set_comment | ( | struct oval_object * | ,
|  | char * | comment )

Sets a copy of the comment parameter to attribute oval_object->comment.

Parameters

  comment | - (Not NULL) the text of the comment.

## oval_object_set_subtype()

OSCAP_API void oval_object_set_subtype | ( | struct oval_object * | ,
|  | oval_subtype_t | subtype )

Sets attributes oval_object->subtype and oval_object->family.

If Oval_object->subtype == OVAL_SUBTYPE_UNKNOWN and parameter subtype <> OVAL_SUBTYPE_UNKNOWN, this method shall overwrite Oval_object->subtype with the value of the subtype parameter and Oval_object->family with the value of oval_family_t corresponding to the specified subtype. Otherwise, the state of the Oval_object instance shall not be changed by this method.

Parameters

  subtype | - the required subtype value.

## oval_object_set_version()

OSCAP_API void oval_object_set_version | ( | struct oval_object * | ,
|  | int | version )

Sets attribute oval_object->version.

If Oval_object->version == 0 and parameter version >0, this method shall overwrite Oval_object->version with the parameter value. Otherwise, the method shall leave the Oval_object state unchanged.

Parameters

  version | - (>0) the required version

## oval_reference_clone()

OSCAP_API struct oval_reference * oval_reference_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_reference * | old_reference )

Returns
  A copy of the specified oval_reference.

## oval_reference_get_id()

OSCAP_API char * oval_reference_get_id | ( | struct oval_reference * |  | ) |

Get OVAL reference ID.

Returns
  A pointer to the id attribute of the specified oval_reference.

## oval_reference_get_source()

OSCAP_API char * oval_reference_get_source | ( | struct oval_reference * |  | ) |

Get OVAL reference source.

Returns
  A pointer to the source attribute of the specified oval_reference.

## oval_reference_get_url()

OSCAP_API char * oval_reference_get_url | ( | struct oval_reference * |  | ) |

Get OVAL reference URL.

Returns
  A pointer to the url attribute of the specified oval_reference.

## oval_setobject_clone()

OSCAP_API struct oval_setobject * oval_setobject_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_setobject * | old_setobject )

Returns
  A copy of the specified oval_setobject.

## oval_setobject_get_filters()

OSCAP_API struct oval_filter_iterator * oval_setobject_get_filters | ( | struct oval_setobject * |  | ) |

Get OVAL set object filters.

This works only with sets of OVAL_SET_COLLECTIVE type.

Returns
  A new iterator for the filters attribute of the specified oval_setobject. It should be freed after use by the calling application.

## oval_setobject_get_objects()

OSCAP_API struct oval_object_iterator * oval_setobject_get_objects | ( | struct oval_setobject * |  | ) |

Get OVAL set object referenced objects.

This works only with sets of OVAL_SET_COLLECTIVE type.

Returns
  A new iterator for the objects attribute of the specified oval_setobject. It should be freed after use by the calling application.

## oval_setobject_get_subsets()

OSCAP_API struct oval_setobject_iterator * oval_setobject_get_subsets | ( | struct oval_setobject * |  | ) |

Get OVAL set object subsets.

This works only with sets of OVAL_SET_AGGREGATE type.

Returns
  A new iterator for the subsets attribute of the specified oval_setobject. It should be freed after use by the calling application.

## oval_state_add_content()

OSCAP_API void oval_state_add_content | ( | struct oval_state * | ,
|  | struct oval_state_content * | content )

Append instance of oval_state_content to attribute oval_state->state_contents.

oval_state_contents appended to a given oval_state shall be freed by the API when the oval_state is freed.

Note
  A specific instance of oval_state_content should not be appended to more than one oval_state, and an instance of oval_state_content should not be appended more than once to a single oval_state.
  An instance of oval_state_content that is appended to an oval_state should not be freed independently by the application using oval_state_content_free.

Parameters

  content | - (Not NULL) the oval_state_content to be appended.

## oval_state_add_note()

OSCAP_API void oval_state_add_note | ( | struct oval_state * | ,
|  | char * | note )

Appends a copy of the note parameter to attribute oval_state->notes.

Parameters

  note | - (Not NULL) the text of the appended note.

## oval_state_clone()

OSCAP_API struct oval_state * oval_state_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_state * | old_state )

Clone instance of oval_state and add it to the specified oval_definition_model.

Returns
  A copy of the specified oval_state.

## oval_state_content_clone()

OSCAP_API struct oval_state_content * oval_state_content_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_state_content * | old_content )

Returns
  A copy of the specified oval_state_content.

## oval_state_content_get_check_existence()

OSCAP_API oval_existence_t oval_state_content_get_check_existence | ( | struct oval_state_content * | content | ) |

Get "check_existence" attribute of an OVAL state entity.

Parameters

  content | An entity within the state element

Returns
  Value of the check_existence attribute

## oval_state_content_get_entity()

OSCAP_API struct oval_entity * oval_state_content_get_entity | ( | struct oval_state_content * |  | ) |

Get entity of a state content.

Returns
  A pointer to the entity attribute of the specified oval_state_content.

## oval_state_content_set_check_existence()

OSCAP_API void oval_state_content_set_check_existence | ( | struct oval_state_content * | content,
|  | oval_existence_t | existence )

Sets the "check_existence" attribute of an OVAL state entity.

Parameters

  content | An entity within the state element
  existence | New value of check_existence attribute of that entity

## oval_state_get_comment()

OSCAP_API char * oval_state_get_comment | ( | struct oval_state * |  | ) |

Returns attribute oval_state->comment.

Returns
  A pointer to the comment attribute of the specified oval_state.

## oval_state_get_contents()

OSCAP_API struct oval_state_content_iterator * oval_state_get_contents | ( | struct oval_state * |  | ) |

Returns attribute oval_state->contents.

Returns
  A new iterator for the contents attribute of the specified oval_state. It should be freed after use by the calling application.

## oval_state_get_id()

OSCAP_API char * oval_state_get_id | ( | struct oval_state * |  | ) |

Returns attribute oval_state->id.

Returns
  A pointer to the id attribute of the specified oval_state.

## oval_state_get_name()

OSCAP_API const char * oval_state_get_name | ( | struct oval_state * |  | ) |

Returns the name of an oval_state.

This is a convenience method that is equivalent to oval_subtype_get_text (oval_state_get_subtype)+"_state".

## oval_state_get_notes()

OSCAP_API struct oval_string_iterator * oval_state_get_notes | ( | struct oval_state * |  | ) |

Returns attribute oval_state->notes.

Returns
  A new iterator for the notes attribute of the specified oval_state. It should be freed after use by the calling application.

## oval_state_new()

OSCAP_API struct oval_state * oval_state_new | ( | struct oval_definition_model * | ,
|  | const char * | id )

Construct new intance of oval_state.

Attribute values shall be initialized:

- family – initialized to OVAL_FAMILY_UNKNOWN
- subtype – initialized to OVAL_SUBTYPE_UNKNOWN
- notes – initialized to empty iterator
- comment – initialized to NULL
- id – initialized to a copy of the id parameter
- deprecated – initialized to false
- version – initialized to zero
- operator – initialized to OVAL_OPERATOR_AND
- contents – initialized to empty iterator

Note
  This method shall not construct a new instance of Oval_state and shall return NULL if the text of the id parameter is not matched by the regular expression ^oval:[.A-Za-z0-9_-]+:stt:[1-9][0-9]*$.

Parameters

  id | - (Not NULL) the text of the required state id.

## oval_state_set_comment()

OSCAP_API void oval_state_set_comment | ( | struct oval_state * | ,
|  | char * | comment )

Sets a copy of the comment parameter to attribute oval_state->comment.

Parameters

  comment | - (Not NULL) the text of the comment.

## oval_state_set_subtype()

OSCAP_API void oval_state_set_subtype | ( | struct oval_state * | ,
|  | oval_subtype_t | subtype )

Sets attributes oval_state->subtype and oval_state->family.

If oval_state->subtype == OVAL_SUBTYPE_UNKNOWN and parameter subtype <> OVAL_SUBTYPE_UNKNOWN, this method shall overwrite oval_state->subtype with the value of the subtype parameter and oval_state->family with the value of oval_family_t corresponding to the specified subtype. Otherwise, the state of the oval_state instance shall not be changed by this method.

Parameters

  subtype | - the required subtype value.

## oval_state_set_version()

OSCAP_API void oval_state_set_version | ( | struct oval_state * | ,
|  | int | version )

Sets attribute oval_state->version.

If oval_state->version == 0 and parameter version >0, this method shall overwrite oval_state->version with the parameter value. Otherwise, the method shall leave the oval_state state unchanged.

Parameters

  version | - (>0) the required version

## oval_test_add_note()

OSCAP_API void oval_test_add_note | ( | struct oval_test * | ,
|  | char * | note )

Appends a copy of the note parameter to attribute oval_test->notes.

Parameters

  note | - (Not NULL) the text of the appended note.

## oval_test_add_state()

OSCAP_API void oval_test_add_state | ( | struct oval_test * | ,
|  | struct oval_state * | )

Add the specified state to the state list of the specified test.

Parameters

  state | - (<> NULL) the required state

## oval_test_clone()

OSCAP_API struct oval_test * oval_test_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_test * | old_test )

Clone instance of oval_test and add it to the specified oval_definition_model.

Returns
  A copy of the specified oval_test.

## oval_test_get_comment()

OSCAP_API char * oval_test_get_comment | ( | struct oval_test * |  | ) |

Returns attribute Oval_test->comment.

Returns
  A pointer to the comment attribute of the specified oval_test.

## oval_test_get_id()

OSCAP_API char * oval_test_get_id | ( | struct oval_test * |  | ) |

Returns attribute oval_test->id.

Returns
  A pointer to the id attribute of the specified oval_test.

## oval_test_get_notes()

OSCAP_API struct oval_string_iterator * oval_test_get_notes | ( | struct oval_test * |  | ) |

Returns attribute oval_test->notes.

Returns
  A new iterator for the notes attribute of the specified oval_test. It should be freed after use by the calling application.

## oval_test_get_object()

OSCAP_API struct oval_object * oval_test_get_object | ( | struct oval_test * |  | ) |

Returns attribute oval_test->object.

Returns
  A pointer to the object attribute of the specified oval_test.

## oval_test_get_states()

OSCAP_API struct oval_state_iterator * oval_test_get_states | ( | struct oval_test * |  | ) |

Returns attribute oval_test->states.

Returns
  A new iterator for the states attribute of the specified oval_test. It should be freed after use by the calling application.

## oval_test_new()

OSCAP_API struct oval_test * oval_test_new | ( | struct oval_definition_model * | ,
|  | const char * | id )

Construct new instance of oval_test.

Attribute values shall be initialized:

- family – initialized to OVAL_FAMILY_UNKNOWN
- subtype – initialized to OVAL_SUBTYPE_UNKNOWN
- notes – initialized to empty iterator.
- comment – initialized to NULL
- id – initialized to a copy of the id parameter
- deprecated – initialized to false
- version – initialized to zero
- existence – initialized to OVAL_CHECK_UNKNOWN
- check – initialized to OVAL_CHECK_UNKNOWN
- object – initialized to NULL
- state – initialized to NULL

Note
  This method shall not construct a new instance of Oval_test and shall return NULL if the text of the id parameter is not matched by the regular expression ^oval:[.A-Za-z0-9_-]+:tst:[1-9][0-9]*$.

Parameters

  id | - (Not NULL) the text of the required test id.

## oval_test_set_check()

OSCAP_API void oval_test_set_check | ( | struct oval_test * | ,
|  | oval_check_t | )

Sets attribute oval_test->check.

If Oval_test->check == OVAL_CHECK_UNKNOWN and parameter check <> OVAL_CHECK_UNKNOWN, this method shall overwrite Oval_test->check with the parameter check. Otherwise, the method shall leave the Oval_test state unchanged.

Note
  If Oval_test->state == NULL, the value of Oval_test->check is ignored.

Parameters

  check | - (<> OVAL_CHECK_UNKNOWN) the required check

## oval_test_set_comment()

OSCAP_API void oval_test_set_comment | ( | struct oval_test * | ,
|  | char * | comment )

Sets a copy of the comment parameter to attribute oval_test->comment.

Parameters

  comment | - (Not NULL) the text of the comment.

## oval_test_set_existence()

OSCAP_API void oval_test_set_existence | ( | struct oval_test * | ,
|  | oval_existence_t | )

Sets attribute oval_test->existence.

If Oval_test->existence == OVAL_CHECK_UNKNOWN and parameter existence <> OVAL_CHECK_UNKNOWN, this method shall overwrite Oval_test->existence with the parameter value. Otherwise, the method shall leave the Oval_test state unchanged.

Parameters

  existence | - (<> OVAL_CHECK_UNKNOWN) the required existence

## oval_test_set_object()

OSCAP_API void oval_test_set_object | ( | struct oval_test * | ,
|  | struct oval_object * | )

Sets attribute oval_test->object.

If Oval_test->object == NULL and parameter object <> NULL, this method shall overwrite Oval_test->object with the parameter object. Otherwise, the method shall leave the Oval_test state unchanged.

Parameters

  object | - (<> NULL) the required object

## oval_test_set_subtype()

OSCAP_API void oval_test_set_subtype | ( | struct oval_test * | ,
|  | oval_subtype_t | subtype )

Sets attributes oval_test->subtype and Oval_test->family.

If Oval_test->subtype == OVAL_SUBTYPE_UNKNOWN and parameter subtype <> OVAL_SUBTYPE_UNKNOWN, this method shall overwrite Oval_test->subtype with the value of the subtype parameter and Oval_test->family with the value of oval_family_t corresponding to the specified subtype. Otherwise, the state of the Oval_test instance shall not be changed by this method.

Parameters

  subtype | - the required subtype value.

## oval_test_set_version()

OSCAP_API void oval_test_set_version | ( | struct oval_test * | ,
|  | int | version )

Sets attribute oval_test->version.

If Oval_test->version == 0 and parameter version >0, this method shall overwrite Oval_test->version with the parameter value. Otherwise, the method shall leave the Oval_test state unchanged.

Parameters

  version | - (>0) the required version

## oval_value_clone()

OSCAP_API struct oval_value * oval_value_clone | ( | struct oval_value * | old_value | ) |

Returns
  A copy of the specified oval_value.

## oval_value_get_text()

OSCAP_API char * oval_value_get_text | ( | struct oval_value * |  | ) |

Get OVAL value as a text.

Returns
  A pointer to the text attribute of the specified oval_value.

## oval_variable_add_possible_restriction()

OSCAP_API void oval_variable_add_possible_restriction | ( | struct oval_variable * | variable,
|  | struct oval_variable_possible_restriction * | pr )

Add a new possible restriction to an external variable.

Parameters

  variable | Variable to add.
  pr | The new possible_restriction.

## oval_variable_add_possible_value()

OSCAP_API void oval_variable_add_possible_value | ( | struct oval_variable * | variable,
|  | struct oval_variable_possible_value * | pv )

Add a new possible value to an external variable.

Parameters

  variable | Variable to add.
  pv | The new possible_value.

## oval_variable_add_value()

OSCAP_API void oval_variable_add_value | ( | struct oval_variable * | ,
|  | struct oval_value * | )

Append an instance of Oval_value to the attribute Oval_constant->values.

If attribute type <> OVAL_VARIABLE_CONSTANT or the value parameter is NULL the state of the oval_variable shall not be changed by this method. Otherwise, The value parameter shall be appended and shall be freed by the API when the Oval_constant is freed

Note
  When a value is appended to an Oval_constant by an application, that value should not be subsequently freed by the application using oval_value_free.
  An application should not append an Oval_value to more than one Oval_constant, and that an Oval_value should not be bound more than once to a single Oval_constant.

Parameters

  value | - the required value.

## oval_variable_clone()

OSCAP_API struct oval_variable * oval_variable_clone | ( | struct oval_definition_model * | new_model,
|  | struct oval_variable * | old_variable )

Clone instance of oval_variable and add it to the specified oval_definition_model.

Returns
  A copy of the specified oval_variable.

## oval_variable_get_comment()

OSCAP_API char * oval_variable_get_comment | ( | struct oval_variable * |  | ) |

Returns attribute oval_variable->comment.

Returns
  A pointer to the comment attribute of the specified oval_variable.

## oval_variable_get_component()

OSCAP_API struct oval_component * oval_variable_get_component | ( | struct oval_variable * |  | ) |

Returns attribute Oval_local->component.

If attribute type <> OVAL_VARIABLE_LOCAL this method shall return NULL.

Returns
  A pointer to the component attribute of the specified oval_variable.

## oval_variable_get_id()

OSCAP_API char * oval_variable_get_id | ( | struct oval_variable * |  | ) |

Returns attribute oval_variable->id.

Returns
  A pointer to the id attribute of the specified oval_variable.

## oval_variable_get_possible_restrictions2()

OSCAP_API struct oval_variable_possible_restriction_iterator * oval_variable_get_possible_restrictions2 | ( | struct oval_variable * | variable | ) |

Get list of constraints for an external variable.

Returns
  A new iterator for the possible_restriction attribute of the specified oval_variable. It should be freed after use by the calling application.

## oval_variable_get_possible_values2()

OSCAP_API struct oval_variable_possible_value_iterator * oval_variable_get_possible_values2 | ( | struct oval_variable * | variable | ) |

Get list of allowed values for an external variable.

Returns
  A new iterator for the possible_value attribute of the specified oval_variable. It should be freed after use by the calling application.

## oval_variable_get_values()

OSCAP_API struct oval_value_iterator * oval_variable_get_values | ( | struct oval_variable * |  | ) |

Returns attribute Oval_external/ Oval_constant->values.

If attribute type == OVAL_VARIABLE_LOCAL or OVAL_VARIABLE_UNKNOWN, this method shall return NULL

Returns
  A new iterator for the values attribute of the specified oval_variable. It should be freed after use by the calling application.

## oval_variable_new()

OSCAP_API struct oval_variable * oval_variable_new | ( | struct oval_definition_model * | model,
|  | const char * | id,
|  | oval_variable_type_t | type )

Construct new instance of oval_variable.

Attribute values shall be initialized:

- id – initialized to a copy of the id parameter
- type – initialized to the type parameter
- version – initialized to zero
- deprecated – initialized to false
- comment – initialized to NULL
- datatype – initialzed to OVAL_DATATYPE_UNKNOWN
- If type == OVAL_VARIABLE_CONSTANT
  - values – initialized to empty iterator
- If type == OVAL_VARIABLE_EXTERNAL
  - values – initialized to NULL
- If type == OVAL_VARIABLE_LOCAL
  - component – initialized to NULL

This method shall not construct a new instance of oval_variable and shall return NULL

- if the text of the id parameter is not matched by the regular expression ^oval:[.A-Za-z0-9_-]+:var:[1-9][0-9]*$.

if the value of the type parameter is OVAL_VARIABLE_UNKNOWN.

Parameters

  id | - (Not NULL) the text of the required variable id.
  type | - (Not OVAL_VARIABLE_UNKNOWN) the required type.

## oval_variable_possible_restriction_add_restriction()

OSCAP_API void oval_variable_possible_restriction_add_restriction | ( | struct oval_variable_possible_restriction * | pr,
|  | struct oval_variable_restriction * | r )

Add a restriction to the list of possible restrictions.

Parameters

  pr | A possible_restriction type
  r | Restriction which will be added

## oval_variable_possible_restriction_get_hint()

OSCAP_API char * oval_variable_possible_restriction_get_hint | ( | struct oval_variable_possible_restriction * | possible_restriction | ) |

Get hint of possible_restriction element.

Returns
  hint

## oval_variable_possible_restriction_get_operator()

OSCAP_API oval_operator_t oval_variable_possible_restriction_get_operator | ( | struct oval_variable_possible_restriction * | possible_restriction | ) |

Get operator of possible_restriction element.

Returns
  operator

## oval_variable_possible_restriction_get_restrictions2()

OSCAP_API struct oval_variable_restriction_iterator * oval_variable_possible_restriction_get_restrictions2 | ( | struct oval_variable_possible_restriction * | possible_restriction | ) |

Get restrictions from one possible_restriction element.

Returns
  A new iterator for the restriction attribute of possible_restriction. It should be freed after use by the calling application.

## oval_variable_possible_restriction_new()

OSCAP_API struct oval_variable_possible_restriction * oval_variable_possible_restriction_new | ( | oval_operator_t | ,
|  | const char * | )

Construct new instance of possible_restriction element.

Parameters

  operator | Operator to evaluation
  hint | A short description of what the value means or represents.

## oval_variable_possible_value_new()

OSCAP_API struct oval_variable_possible_value * oval_variable_possible_value_new | ( | const char * | hint,
|  | const char * | value )

Construct new instance of possible_value element.

Parameters

  hint | A short description of what the value means or represents.
  value | An expected value of an external variable

## oval_variable_restriction_new()

OSCAP_API struct oval_variable_restriction * oval_variable_restriction_new | ( | oval_operation_t | operation,
|  | const char * | value )

Construct new instance of restriction element.

Parameters

  operation | Operation of restriction.
  value | Restriction placed on expected values for an external variable.

## oval_variable_set_comment()

OSCAP_API void oval_variable_set_comment | ( | struct oval_variable * | ,
|  | char * | comment )

set attribute oval_variable->comment.

If attribute oval_variable->comment == NULL this method shall overwrite the attribute with a copy of the comment parameter. Otherwise the variable state shall be unchanged.

Parameters

  comm | - (Not NULL) a copy of the comment parameter is set as the comment attribute.

## oval_variable_set_component()

OSCAP_API void oval_variable_set_component | ( | struct oval_variable * | ,
|  | struct oval_component * | component )

Bind an instance of Oval_component to the attribute Oval_local->component.

If attribute type <> OVAL_VARIABLE_LOCAL, the component attribute <> NULL or the component parameter is NULL the state of the oval_variable shall not be changed by this method. Otherwise, The component parameter shall be bound to the component attribute and shall be freed by the API when the Oval_local is freed

Note
  When an Oval_component is bound to an Oval_local by an application, the Oval_component should not be subsequently freed by the application using oval_component_free.
  An application should not bind a single Oval_component to more than one Oval_local or to an Oval_local and an Oval_function.

Parameters

  component | - the required component.

## oval_variable_set_datatype()

OSCAP_API void oval_variable_set_datatype | ( | struct oval_variable * | ,
|  | oval_datatype_t | )

set attribute oval_variable->datatype.

If attribute oval_variable->datatype == OVAL_DATATYPE_UNKNOWN this method shall overwrite the attribute with the datatype parameter. Otherwise the variable state shall be unchanged.

Parameters

  datatype | - (Not OVAL_DATATYPE_UNKNOWN) a the required datatype.

## oval_variable_set_deprecated()

OSCAP_API void oval_variable_set_deprecated | ( | struct oval_variable * | ,
|  | bool | deprecated )

set attribute oval_variable->deprecated.

Parameters

  deprecated | - the required deprecation toggle.

## oval_variable_set_version()

OSCAP_API void oval_variable_set_version | ( | struct oval_variable * | ,
|  | int | version )

set attribute oval_variable->version.

If attribute oval_variable->version == 0 this method shall overwrite the attribute with the version parameter. Otherwise the variable state shall be unchanged.

Parameters

  version | - (>0) the required version.